package com.oilabs.map.insuideindoor.utils

import com.indooratlas.android.sdk.IALocation
import com.indooratlas.android.sdk.IAPOI
import com.indooratlas.android.sdk.IARoute
import com.indooratlas.android.sdk.resources.IAFloorPlan
import com.indooratlas.android.sdk.resources.IALatLng

sealed class ChannelData {
    data class Image(val floorPlan: IAFloorPlan) : ChannelData() {

    }

    data class Location(val location: IALocation) : ChannelData()

    data class PoIs(val pois: List<IAPOI>, val currentFloorLevel: Int) : ChannelData()

    data class Destination(val latLng: IALatLng) : ChannelData()

    data class UpdateRouteVisualization(val leg: IARoute.Leg) : ChannelData()

    data class UpdateCamera(val center: IALatLng, val zoom: Float) : ChannelData()

    data class UpdateHeading(val heading: Double) : ChannelData()

    object ClearPolylines : ChannelData()
}