package com.oilabs.map.insuideindoor.wayfinding

import android.content.Context
import com.oilabs.map.insuideindoor.utils.ChannelData
import com.indooratlas.android.sdk.*
import com.indooratlas.android.sdk.resources.IAFloorPlan
import com.indooratlas.android.sdk.resources.IALatLng

interface IAWayfinding {
    fun setupPoIs(pois: List<IAPOI>, currentFloorLevel: Int)

    fun fetchAndSetFloorPlan(floorPlan: IAFloorPlan?)

    fun setWayfindingTarget(point: IALatLng, addMarker: Boolean)

    fun hasArrivedToDestination(route: IARoute): Boolean

    fun clearRouteVisualization()

    fun updateRouteVisualization()

    val mWayfindingListener: IAWayfindingListener

    val mRegionListener: IARegion.Listener

    val mListener: IALocationListener

    fun updateHeading(heading: Double)

    val mOrientationListener: IAOrientationListener

    fun onDestroy()

    fun onPause()

    fun onResume()

    fun setUpIAWayfinding(
        context: Context,
        sendDataToFlutter: (ChannelData) -> Unit
    )

    fun ping(): String
}