import 'ia_status.dart';

class IAConfiguration {
  final String apiKey;
  final String endpoint;
  final double minChangeMeters;
  final double minIntervalSeconds;
  final IAPositioningMode positioningMode;
  final int? floorLock;
  final bool indoorLock;
  const IAConfiguration({
    required this.apiKey,
    this.endpoint = '',
    this.minChangeMeters = 0.7,
    this.minIntervalSeconds = 2,
    this.positioningMode = IAPositioningMode.highAccuracy,
    this.floorLock,
    this.indoorLock = true,
  });

  IAConfiguration copyWithEx({
    String? apiKey,
    String? endpoint,
    double? minChangeMeters,
    double? minIntervalSeconds,
    IAPositioningMode? positioningMode,
    int? floorLock, // this is always applied
    bool? indoorLock,
  }) =>
      IAConfiguration(
        apiKey: apiKey ?? this.apiKey,
        endpoint: endpoint ?? this.endpoint,
        minChangeMeters: minChangeMeters ?? this.minChangeMeters,
        minIntervalSeconds: minIntervalSeconds ?? this.minIntervalSeconds,
        positioningMode: positioningMode ?? this.positioningMode,
        floorLock: floorLock,
        indoorLock: indoorLock ?? this.indoorLock,
      );

  IAConfiguration copyWith({
    String? apiKey,
    String? endpoint,
    double? minChangeMeters,
    double? minIntervalSeconds,
    IAPositioningMode? positioningMode,
    bool? indoorLock,
  }) =>
      copyWithEx(
        apiKey: apiKey,
        endpoint: endpoint,
        minChangeMeters: minChangeMeters,
        minIntervalSeconds: minIntervalSeconds,
        positioningMode: positioningMode,
        floorLock: floorLock,
        indoorLock: indoorLock,
      );

  IAConfiguration copyFloorLocked(int? floorLock) =>
      copyWithEx(floorLock: floorLock);
}
