// ignore_for_file: public_member_api_docs, sort_constructors_first
import 'dart:convert';

import 'package:equatable/equatable.dart';

class IACoordinate extends Equatable {
  final double latitude;
  final double longitude;
  const IACoordinate(
    this.latitude,
    this.longitude,
  );
  const IACoordinate.zero()
      : latitude = 0,
        longitude = 0;

  IACoordinate copyWith({
    double? latitude,
    double? longitude,
  }) {
    return IACoordinate(
      latitude ?? this.latitude,
      longitude ?? this.longitude,
    );
  }

  Map<String, dynamic> toMap() {
    return <String, dynamic>{
      'latitude': latitude,
      'longitude': longitude,
    };
  }

  factory IACoordinate.fromMap(Map<String, dynamic> map) {
    return IACoordinate(
      map['latitude'] as double,
      map['longitude'] as double,
    );
  }

  String toJson() => json.encode(toMap());

  factory IACoordinate.fromJson(String source) => IACoordinate.fromMap(json.decode(source) as Map<String, dynamic>);

  @override
  bool get stringify => true;

  @override
  List<Object> get props => [latitude, longitude];
}
