import 'ia_coordinate.dart';

class IAFloorplan {
  final String id;
  final String name;
  final String url;
  final int floor;
  final double bearing;
  final int bitmapWidth;
  final int bitmapHeight;
  final double widthMeters;
  final double heightMeters;
  final double metersToPixels;
  final double pixelsToMeters;
  final IACoordinate bottomLeft;
  final IACoordinate bottomRight;
  final IACoordinate center;
  final IACoordinate topLeft;
  final IACoordinate topRight;
  IAFloorplan.fromMap(Map map)
      : id = map['id'],
        name = map['name'],
        url = map['url'],
        floor = map['floorLevel'],
        bearing = map['bearing'],
        bitmapWidth = map['bitmapWidth'],
        bitmapHeight = map['bitmapHeight'],
        widthMeters = map['widthMeters'],
        heightMeters = map['heightMeters'],
        metersToPixels = map['metersToPixels'],
        pixelsToMeters = map['pixelsToMeters'],
        bottomLeft = IACoordinate(map['bottomLeft'][1], map['bottomLeft'][0]),
        bottomRight =
            IACoordinate(map['bottomRight'][1], map['bottomRight'][0]),
        center = IACoordinate(map['center'][1], map['center'][0]),
        topLeft = IACoordinate(map['topLeft'][1], map['topLeft'][0]),
        topRight = IACoordinate(map['topRight'][1], map['topRight'][0]);

  // Future<IAPoint> pointFromCoordinate(IACoordinate coord) async {
  //   // TODO: native side not implemented
  //   throw ('not implemented');
  //   final r = await IndoorAtlas._nativeInitialized<List<double>>(
  //       'pointFromCoordinate', [id, coord.latitude, coord.longitude]);
  //   return IAPoint(r![0], r[1]);
  // }

  // Future<IACoordinate> coordinateFromPoint(IAPoint point) async {
  //   // TODO: native side not implemented
  //   throw ('not implemented');
  //   final r = await IndoorAtlas._nativeInitialized<List<double>>(
  //       'coordinateFromPoint', [id, point.x, point.y]);
  //   return IACoordinate(r![0], r[1]);
  // }
}
