import 'ia_coordinate.dart';

class IAGeofence {
  final String id;
  final String name;
  final int floor;
  late final List<IACoordinate> coordinates;
  final String payload;
  IAGeofence({
    required this.id,
    this.name = '',
    this.floor = 0,
    required this.coordinates,
    this.payload = '',
  });
  IAGeofence.fromGeoJson(Map map)
      : id = map['id'],
        name = map['properties']['name'],
        floor = map['properties']['floor'],
        payload = map['properties']['payload'] {
    List<IACoordinate> coords = [];
    for (var coord in map['geometry']['coordinates'][0]) {
      coords.add(IACoordinate(coord[1], coord[0]));
    }
    coordinates = coords;
  }
  // TODO: toGeoJson
}
