// ignore_for_file: public_member_api_docs, sort_constructors_first
import 'dart:convert';

import 'package:latlong2/latlong.dart';

class IALatLng extends LatLng {
  @override
  final double latitude;
  @override
  final double longitude;
  IALatLng(
    this.latitude,
    this.longitude,
  ) : super(latitude, longitude);

  IALatLng copyWith({
    double? latitude,
    double? longitude,
  }) {
    return IALatLng(
      latitude ?? this.latitude,
      longitude ?? this.longitude,
    );
  }

  Map<String, dynamic> toMap() {
    return <String, dynamic>{
      'latitude': latitude,
      'longitude': longitude,
    };
  }

  factory IALatLng.fromMap(Map<String, dynamic> map) {
    return IALatLng(
      map['latitude'] as double,
      map['longitude'] as double,
    );
  }

  // @override
  // String toJson() => json.encode(toMap());

  factory IALatLng.fromJson(String source) =>
      IALatLng.fromMap(json.decode(source) as Map<String, dynamic>);

  @override
  String toString() => 'IALatLng(latitude: $latitude, longitude: $longitude)';

  @override
  bool operator ==(covariant IALatLng other) {
    if (identical(this, other)) return true;

    return other.latitude == latitude && other.longitude == longitude;
  }

  @override
  int get hashCode => latitude.hashCode ^ longitude.hashCode;
}
