import 'package:flutter/foundation.dart';

import 'ia_floorplan.dart';
import 'ia_location.dart';
import 'ia_route.dart';
import 'ia_status.dart';
import 'ia_venue.dart';
import 'ia_wayfindingrequest.dart';

abstract class IAListener {
  final UniqueKey key; // make sure every instance is unique
  final String name;
  // TODO: add IAWayfindingRequest
  // TODO: add IAGeofence array (for dynamic geofences)
  IAListener(this.name) : key = UniqueKey();
  void onStatus(IAStatus status, String message);
  void onLocation(IALocation location);
  void onVenue(bool enter, IAVenue venue);
  void onFloorplan(bool enter, IAFloorplan floorplan);
  void onWayfindingRoute(IARoute route, IAWayfindingRequest? request);
  void onOrientation(double x, double y, double z, double w);
  void onHeading(double heading);
}
