// ignore_for_file: public_member_api_docs, sort_constructors_first

import 'dart:convert';

import 'ia_coordinate.dart';

class IAPOI {
  final String id;
  final String name;
  final int floor;
  final IACoordinate coordinate;
  final String payload;

  IAPOI({
    required this.id,
    required this.name,
    required this.floor,
    required this.coordinate,
    required this.payload,
  });

  IAPOI.fromGeoJson(Map map)
      : id = map['id'],
        name = map['properties']['name'],
        floor = map['properties']['floor'],
        coordinate = IACoordinate(map['geometry']['coordinates'][1],
            map['geometry']['coordinates'][0]),
        payload = map['properties']['payload'];

  Map<String, dynamic> toMap() {
    return <String, dynamic>{
      'id': id,
      'name': name,
      'floor': floor,
      'coordinate': coordinate.toMap(),
      'payload': payload,
    };
  }

  factory IAPOI.fromMap(Map<String, dynamic> map) {
    return IAPOI(
      id: map['id'] as String,
      name: map['name'] as String,
      floor: map['floor'] as int,
      coordinate:
          IACoordinate.fromMap(map['coordinate'] as Map<String, dynamic>),
      payload: map['payload'] as String,
    );
  }

  String toJson() => json.encode(toMap());

  factory IAPOI.fromJson(String source) =>
      IAPOI.fromMap(json.decode(source) as Map<String, dynamic>);
}
