// ignore_for_file: public_member_api_docs, sort_constructors_first
import 'dart:convert';

class IAPoint {
  final double x;
  final double y;
  const IAPoint(
    this.x,
    this.y,
  );
  const IAPoint.zero()
      : x = 0,
        y = 0;

  IAPoint copyWith({
    double? x,
    double? y,
  }) {
    return IAPoint(
      x ?? this.x,
      y ?? this.y,
    );
  }

  Map<String, dynamic> toMap() {
    return <String, dynamic>{
      'x': x,
      'y': y,
    };
  }

  factory IAPoint.fromMap(Map<String, dynamic> map) {
    return IAPoint(
      map['x'] as double,
      map['y'] as double,
    );
  }

  String toJson() => json.encode(toMap());

  factory IAPoint.fromJson(String source) => IAPoint.fromMap(json.decode(source) as Map<String, dynamic>);

  @override
  String toString() => 'IAPoint(x: $x, y: $y)';

  @override
  bool operator ==(covariant IAPoint other) {
    if (identical(this, other)) return true;
  
    return 
      other.x == x &&
      other.y == y;
  }

  @override
  int get hashCode => x.hashCode ^ y.hashCode;
}
