import 'ia_floorplan.dart';
import 'ia_venue.dart';

class Region {
  final String id;
  final int type;
  final DateTime timestamp;
  late final IAFloorplan? floorplan;
  late final IAVenue? venue;
  Region.fromMap(Map map)
      : id = map['regionId'],
        type = map['regionType'],
        timestamp = DateTime.fromMillisecondsSinceEpoch(map['timestamp']) {
    if (map.containsKey('floorPlan')) {
      floorplan = IAFloorplan.fromMap(map['floorPlan']);
    } else {
      floorplan = null;
    }
    if (map.containsKey('venue')) {
      venue = IAVenue.fromMap(map['venue']);
    } else {
      venue = null;
    }
  }
}
