import 'ia_routingpoint.dart';

class IARoute {
  late final List<IARoutingLeg> legs;
  final String error;
  IARoute(this.legs, this.error);
  IARoute.empty()
      : legs = [],
        error = '';
  IARoute.fromMap(Map map) : error = map['error'] {
    List<IARoutingLeg> legs = [];
    for (var leg in map['legs']) {
      legs.add(IARoutingLeg.fromMap(leg));
    }
    this.legs = legs;
  }
}

class IARoutingLeg {
  final IARoutingPoint begin, end;
  final double direction;
  final double length;
  final int edgeIndex;
  const IARoutingLeg(
    this.begin,
    this.end,
    this.direction,
    this.length,
    this.edgeIndex,
  );

  IARoutingLeg.fromMap(Map map)
      : begin = IARoutingPoint.fromMap(map['begin']),
        end = IARoutingPoint.fromMap(map['end']),
        direction = map['direction'],
        length = map['length'],
        edgeIndex = map['edgeIndex'];
}
