// ignore_for_file: public_member_api_docs, sort_constructors_first
import 'dart:convert';

import 'package:equatable/equatable.dart';

import 'ia_coordinate.dart';

class IARoutingPoint extends Equatable {
  final IACoordinate coordinate;
  final int floor;
  const IARoutingPoint(
    this.coordinate,
    this.floor,
  );
  
  IARoutingPoint.fromMap(Map map)
      : coordinate = IACoordinate(map['latitude'], map['longitude']),
        floor = map['floor'];

  IARoutingPoint copyWith({
    IACoordinate? coordinate,
    int? floor,
  }) {
    return IARoutingPoint(
      coordinate ?? this.coordinate,
      floor ?? this.floor,
    );
  }

  Map<String, dynamic> toMap() {
    return <String, dynamic>{
      'coordinate': coordinate.toMap(),
      'floor': floor,
    };
  }

  String toJson() => json.encode(toMap());

  factory IARoutingPoint.fromJson(String source) => IARoutingPoint.fromMap(json.decode(source) as Map<String, dynamic>);

  @override
  bool get stringify => true;

  @override
  List<Object> get props => [coordinate, floor];
}
