import 'dart:developer';

import 'package:flutter/material.dart';
import 'package:flutter/services.dart';
import 'package:flutter_bloc/flutter_bloc.dart';
import 'package:fluttertoast/fluttertoast.dart';
import 'package:flutter_share/flutter_share.dart';
import 'package:insuideindoor/main/direction.dart';
import 'package:insuideindoor/main/filter_data.dart';
import 'package:http/http.dart' as http;

// import 'package:mapbox_gl_example/http/services.dart';
import 'package:insuideindoor/main/poiInfo.dart';
import 'package:insuideindoor/main/poi_model.dart';
import 'package:insuideindoor/main/services.dart';
import 'package:insuideindoor/main/test.dart';
import 'package:insuideindoor/main/to_direction.dart';
import 'package:insuideindoor/ui/widgets/ia_listener.dart';
import 'package:insuideindoor/utils/constants.dart';
import 'package:insuideindoor/utils/helper.dart';

import 'package:mapbox_gl/mapbox_gl.dart';
import 'package:shared_preferences/shared_preferences.dart';

import '../data/ia/indooratlas.dart';
import '../data/models/models.dart';
import '../utils/common_functions.dart';
import 'bloc/myhome_bloc.dart';

// import 'package:mapbox_gl_example/models/poi_model.dart';

class MyHome extends StatefulWidget {
  final data;
  String mTer;
  String mLev;

  MyHome({Key? key, required this.data, required this.mTer, required this.mLev})
      : super(key: key);

  @override
  State<MyHome> createState() => _MyHomeState();
}

GetPoi? poiPoints;
int? loopCounter;
TextEditingController searchController = TextEditingController();
List<Datum> searchList = [];
List<Datum> dataPois = [];
List recentSearchName = [];
List recentSearchGeo = [];

class _MyHomeState extends State<MyHome> {
  bool level0active = false;
  bool level1active = false;
  bool level2active = false;
  bool level3active = false;
  bool level4active = true;

  // LatLng? latLngPresent = GetLatLngFromSP();
  double? userLat;
  double? userLong;
  double minSize = 0.36;

  late CameraPosition _initialCameraPosition;

  late MapboxMapController controller;
  bool isLoading = true;
  bool finalBool = true;
  bool finalBool2 = true;

  List<LatLng> poisList = [];
  List<String> poisName = [];
  List<String> poiImage = [];
  LatLng? currentLocationIA;
  bool t1 = false;
  LatLng? dynamicLatLng;
  String? kamalString;

  bool isTerminal2Selected = true;
  bool canClose = false;
  var scrollController = ScrollController();
  var dragController = DraggableScrollableController();
  var dragControllerPoi = DraggableScrollableController();

  bool isTer1 = false;

  var isPoiTapped = false;
  late String geo, poiName, iconImage;
  late LatLng currentPoi;

  FocusNode searchFocus = FocusNode();
  var searchTextController = TextEditingController();

  int currentFloor = 0;
  List<IAFloorplan>? floorplans;
  String? selectedPoiForAR;
  List<IAPOI>? allPOIS;

  // List<MapMarker> mapMarkerList = [];
  @override
  void deactivate() {
    // TODO: implement deactivate
    super.deactivate();
  }

  @override
  void initState() {
    super.initState();
    fetchFinalToken();
    allPOIS = getPOIS();
    print("widget.data ${widget.data}");
    LatLng aaa = convertToLatLng();

    searchList.clear();
    if (widget.mTer == "1") {
      setState(() {
        isTerminal2Selected = false;
        isTer1 = true;
      });
    }
    setState(() {
      isLoading = true;
      finalBool = true;
      finalBool2 = true;
    });

    //LatLng(19.093099, 72.856952)

    sharedLatLng().then((value) {
      setState(() {
        _initialCameraPosition = CameraPosition(
            // target: dynamicLatLng ?? LatLng(19.098519, 72.874318),
            target: isTer1
                ? const LatLng(19.092067, 72.853808)
                : const LatLng(19.098519, 72.874318),
            zoom: 17,
            tilt: 30.0);
      });
    });
    sharedStyleString().then((value) {
      setState(() {
        kamalString = value;

        finalBool2 = false;
      });
    });

    WidgetsBinding.instance.addPostFrameCallback((timeStamp) {
      //   scrollController.addListener(() {
      //
      //   });
      //
      //   dragController.addListener(() {
      //     print("dragController");
      //   });
      //
      //   dragControllerPoi.addListener(() {
      //     print("dragControllerPOI");
      //   });

      // searchFocus.addListener(() {
      //   if(searchFocus.hasFocus && searchTextController.text.isNotEmpty){
      //     canClose = true;
      //   }
      // });

      searchTextController.addListener(() {
        print("Controller Value >>>>>>>>>> ${searchTextController.text}");
        if (searchFocus.hasFocus &&
            searchTextController.text.isNotEmpty &&
            !canClose) {
          canClose = true;
        } else if (searchTextController.text.isEmpty) {
          canClose = false;
          print("Controller Value >>>>>>>>>> ${searchTextController.text}");
          setState(() {});
        }
      });
    });
  }

  fetchFinalToken() async {
    await InternetService().fetchToken().then((value) {
      fetchPois(widget.mTer, widget.mLev, value);
    });
  }

  checkCurrentTerNlvl(flrId) {
    switch (flrId) {
      case "0f337c42-8aef-460f-a093-0b7abd7f885a":
        {
          setState(() {
            widget.mTer = "2";
            widget.mLev = "1";
            controller.animateCamera(CameraUpdate.newCameraPosition(
                const CameraPosition(
                    target: LatLng(19.099474, 72.874330),
                    zoom: 20,
                    tilt: 30.0)));
          });
        }
        break;

      case "490d8c62-1989-45d4-8cc3-c1c654c9ec2d":
        {
          setState(() {
            widget.mTer = "2";
            widget.mLev = "2";
            controller.animateCamera(CameraUpdate.newCameraPosition(
                const CameraPosition(
                    target: LatLng(19.098588, 72.874341),
                    zoom: 20,
                    tilt: 30.0)));
          });
        }
        break;
      case "c1bd8e4e-a4b7-4eb9-8657-e8ee7a38189b":
        {
          setState(() {
            widget.mTer = "2";
            widget.mLev = "3";
            controller.animateCamera(CameraUpdate.newCameraPosition(
                const CameraPosition(
                    target: LatLng(19.096827, 72.874386),
                    zoom: 20,
                    tilt: 30.0)));
          });
        }
        break;
      case "083689fb-48d8-4970-93e8-163c7a234390":
        {
          setState(() {
            widget.mTer = "2";
            widget.mLev = "4";
            controller.animateCamera(CameraUpdate.newCameraPosition(
                const CameraPosition(
                    target: LatLng(19.098519, 72.874318),
                    zoom: 20,
                    tilt: 30.0)));
          });
        }
        break;

      case "207147a4-afcc-4fd3-94df-bb30f55fe4d6":
        {
          setState(() {
            widget.mTer = "1";
            widget.mLev = "0";
            controller.animateCamera(CameraUpdate.newCameraPosition(
                const CameraPosition(
                    target: LatLng(19.093099, 72.856952),
                    zoom: 20,
                    tilt: 30.0)));
          });
        }
        break;
      case "f368c30a-784f-4e13-b2f9-5592c5698f91":
        {
          setState(() {
            widget.mTer = "1";
            widget.mLev = "1";
            controller.animateCamera(CameraUpdate.newCameraPosition(
                const CameraPosition(
                    target: LatLng(19.092141, 72.855159),
                    zoom: 20,
                    tilt: 30.0)));
          });
        }
        break;
      case "587d5a31-c5a9-41bb-8eca-854e9fc6456b":
        {
          setState(() {
            widget.mTer = "1";
            widget.mLev = "2";
            controller.animateCamera(CameraUpdate.newCameraPosition(
                const CameraPosition(
                    target: LatLng(19.092067, 72.853808),
                    zoom: 20,
                    tilt: 30.0)));
          });
        }
        break;

      default:
        {
          {
            setState(() {
              widget.mTer = "2";
              widget.mLev = "4";
              controller.animateCamera(CameraUpdate.newCameraPosition(
                  const CameraPosition(
                      target: LatLng(19.098519, 72.874318),
                      zoom: 20,
                      tilt: 30.0)));
            });
          }
        }
        break;
    }
  }

  @override
  dispose() {
    super.dispose();

    searchTextController.removeListener(() {});
  }

  Future<LatLng> sharedLatLng() async {
    setState(() {
      isLoading = true;
    });
    final SharedPreferences sharedPreferences =
        await SharedPreferences.getInstance();
    bool myisTerminal2Selected =
        sharedPreferences.getBool("isTerminal2Selected") ?? true;
    double latt = sharedPreferences.getDouble('lat') ?? 19.098519;
    double longg = sharedPreferences.getDouble('long') ?? 72.874318;
    print("Final LatLng ${LatLng(latt, longg)}");
    setState(() {
      dynamicLatLng = LatLng(latt, longg);
      finalBool = false;
      isTerminal2Selected = myisTerminal2Selected;
    });
    return LatLng(latt, longg);
  }

  Future<String> sharedStyleString() async {
    setState(() {
      isLoading = true;
    });
    final SharedPreferences sharedPreferences =
        await SharedPreferences.getInstance();
    String styleStringMain = sharedPreferences.getString('styleString') ??
        'mapbox://styles/merrillgonsalves/cl508fw8s000u15rsht67q9tx';

    return styleStringMain;
  }

  LatLng convertToLatLng() {
    String a = widget.data;
    List latlng = a.split(',');
    double _lat = double.parse(latlng[0]);
    double _lng = double.parse(latlng[1]);
    LatLng finalIALatLng = LatLng(_lat, _lng);
    return finalIALatLng;
  }

  // String myTer = "2";
  // String myLev = "4";
  void _onMapCreated(MapboxMapController mapboxMapController) {
    controller = mapboxMapController;
  }

  fetchPois(String myTer, String myLev, String newFinalToken) async {
    print("myTer $myTer");
    print("myLev $myLev");
    // final SharedPreferences? sharedPreferences =
    //     await SharedPreferences.getInstance();

    // setState(() {
    //   myTer = sharedPreferences?.getString('terminal') ?? "2";
    //   myLev = sharedPreferences?.getString('level') ?? "4";
    // });
    poiPoints = await InternetService().getPOI(newFinalToken).then((value) {
      loopCounter = value!.data!.length;
      poisList.clear();
      poisName.clear();
      poiImage.clear();

      if (loopCounter! > 0) {
        dataPois = value.data!;
        //
        //   int a = 1;
        //   for (a = 1; a <= loopCounter!; a++) {
        //     if (value.data?[a - 1].terminal == myTer && value.data?[a - 1].levelid == myLev) {
        //       poisList.add(LatLng(value.data![a - 1].lat!, value.data![a - 1].lng!));
        //       poisName.add(value.data?[a - 1].poiMultilingual!.en!.name ?? "Test");
        //       poiImage.add(value.data?[a - 1].subcategory.toString() ?? "EMPTY");
        //     }
        //   }
        //   print("poisList ${poisList.length}");
        //   setState(() {});
        filterPOIs(myTer, myLev);
      }
      return null;

      // return null;
    });
    setState(() {
      isLoading = false;
    });
  }

  filterPOIs(myTer, myLev) {
    poisList.clear();
    poisName.clear();
    poiImage.clear();

    if (loopCounter! > 0) {
      int a = 1;
      for (a = 1; a <= loopCounter!; a++) {
        if (dataPois[a - 1].terminal == myTer &&
            dataPois[a - 1].levelid == myLev) {
          poisList.add(LatLng(dataPois[a - 1].lat!, dataPois[a - 1].lng!));
          poisName.add(dataPois[a - 1].poiMultilingual!.en!.name ?? "Test");
          poiImage.add(dataPois[a - 1].subcategory.toString());
        }
      }
      print("poisList ${poisList.length}");
      setState(() {});
    }
  }

  tappedaFunction(Symbol symbol) {
    print("printSymbol $symbol");
    Fluttertoast.showToast(
      msg: 'Tapped on POI',
    );
  }

  void addSymbol() async {
    if (userLocSymbol != null) {
      controller.removeSymbol(userLocSymbol!);
    }
    // SHOWING CURRENT USER LOCATION ON MAP
    userLocSymbol = await controller.addSymbol(
      const SymbolOptions(
        geometry: LatLng(19.098519, 72.874318),
        // geometry: convertToLatLng(),
        iconImage: "assets/symbols/Oval.png",
        iconSize: 2,
      ),
    );

    controller.onSymbolTapped.add((argument) {
      geo = argument.options.geometry.toString();
      poiName = argument.options.textField.toString();
      iconImage = argument.options.iconImage.toString();
      currentPoi = argument.options.geometry!;
      print(
          "argument.options.geometry!.latitude ${argument.options.geometry!.latitude}");
      print(
          "argument.options.geometry!.latitude ${argument.options.geometry!.longitude}");
      print("currentFloor $currentFloor");
      // isPoiTapped = true;
      // setState(() {});

      Navigator.push(
        context,
        MaterialPageRoute(
            builder: (context) => PoiInfo(
                  geo: argument.options.geometry.toString(),
                  poiName: argument.options.textField.toString(),
                  iconImage: argument.options.iconImage.toString(),
                  onGetDirection: () {
                    print("DIRECTION CALLED");
                    // IndoorAtlas.startWayfindingTo(
                    //   IAWayfindingRequest(
                    //     destination: IACoordinate(
                    //         argument.options.geometry!.latitude,
                    //         argument.options.geometry!.longitude),
                    //     floor: currentFloor,
                    //   ),
                    // );
                    BlocProvider.of<MyhomeBloc>(context).add(HideSecondSheet());
                  },
                )),
      );
//PUSH COMMAND

      // dragController.animateTo(0.0,
      //     duration: const Duration(milliseconds: 500),
      //     curve: Curves.easeOutBack);

      // BlocProvider.of<MyhomeBloc>(context).add(HideFirstSheet());
      // BlocProvider.of<MyhomeBloc>(context).add(ShowSecondSheet());

      // showModalBottomSheet(context: context,
      //     isScrollControlled: true,
      //     isDismissible: false,
      //
      //     builder: (context){
      //   return DraggableScrollableSheet(
      //       initialChildSize: minSize,
      //       minChildSize: minSize,
      //       maxChildSize: 1,
      //       expand: false,
      //       snap: true,
      //       snapSizes: [minSize, 1],
      //       controller: dragControllerPoi,
      //       builder: (BuildContext context, scrollSheetController) {
      //         // scrollController = scrollSheetController;
      //         return Container(
      //           // color: Colors.white,
      //           decoration: const BoxDecoration(
      //               color: Colors.white,
      //               borderRadius: BorderRadius.only(
      //                 topLeft: Radius.circular(32.0),
      //                 topRight: Radius.circular(32.0),
      //               )),
      //           child: ListView.builder(
      //               padding: EdgeInsets.zero,
      //               physics: const ClampingScrollPhysics(),
      //               controller: scrollSheetController,
      //               itemCount: 1,
      //               itemBuilder: (BuildContext context, int index) {
      //                 return PoiInfo(
      //                   geo: geo,
      //                   poiName: poiName,
      //                   iconImage: iconImage,
      //                   isDetail: false,
      //                 );
      //               }),
      //         );
      //       });
      //     }).whenComplete((){
      //   dragController.animateTo(minSize, duration: Duration(milliseconds: 500), curve: Curves.easeOutBack);
      // });

      // showModalBottomSheet<void>(
      //   isDismissible: true,
      //   enableDrag: true,
      //   context: context,
      //   builder: (BuildContext context) {
      //     return PoiInfo(
      //       geo: argument.options.geometry.toString(),
      //       poiName: argument.options.textField.toString(),
      //       iconImage: argument.options.iconImage.toString(),
      //     );
      //   },
      // );
    });

    List<LatLng> lineData = [
      const LatLng(26.255589635625974, 72.9997568091461),
      const LatLng(26.260157, 73.003122),
      const LatLng(26.262075, 72.998984),
      const LatLng(26.267032, 72.993549),
    ];

    controller.addLine(
      LineOptions(
        geometry: lineData,
        lineColor: "#006DB7",
        // lineBlur: 0.5,
        // lineWidth: 8.0,
        lineWidth: 5.0,

        lineOpacity: 1.0,
      ),
    );

    for (int a = 0; a < poisList.length; a++) {
      String iconReturn() {
        if (poiImage[a] == "restaurant" ||
            poiImage[a] == "bar" ||
            poiImage[a] == "cafe" ||
            poiImage[a] == "fast food") {
          return "assets/symbols/restro.png";
        } else if (poiImage[a] == "clothing") {
          return "assets/symbols/clothing.png";
        } else if (poiImage[a] == "bar") {
          return "assets/symbols/restro.png";
        } else if (poiImage[a] == "travel & books") {
          return "assets/symbols/travelbook.png";
        } else if (poiImage[a] == "electronics") {
          //to be updated
          return "assets/symbols/travelbook.png";
        } else if (poiImage[a] == "gifts & toys") {
          return "assets/symbols/gift.png";
        } else if (poiImage[a] == "atm") {
          return "assets/symbols/atm.png";
        } else if (poiImage[a] == "Currency exchange") {
          return "assets/symbols/currencyexchange.png";
        } else if (poiImage[a] == "Lounge") {
          return "assets/symbols/lounge.png";
        } else if (poiImage[a] == "Telephone") {
          return "assets/symbols/telephone.png";
        } else if (poiImage[a] == "Children's play area") {
          return "assets/symbols/playarea.png";
        } else if (poiImage[a] == "Ticket counter") {
          return "assets/symbols/ticketcounter.png";
        } else if (poiImage[a] == "Tourism") {
          return "assets/symbols/tourism.png";
        } else if (poiImage[a] == "Post office") {
          return "assets/symbols/postoffice.png";
        } else if (poiImage[a] == "Baby changing room ") {
          return "assets/symbols/babychange.png";
        } else if (poiImage[a] == "Baggage claim") {
          return "assets/symbols/baggageclaim.png";
        } else if (poiImage[a] == "bus") {
          return "assets/symbols/bus.png";
        } else if (poiImage[a] == "car") {
          return "assets/symbols/car.png";
        } else if (poiImage[a] == "Check-in counters") {
          return "assets/symbols/checkin.png";
        } else if (poiImage[a] == "Customs") {
          return "assets/symbols/customs.png";
        } else if (poiImage[a] == "Escalator") {
          return "assets/symbols/escalator.png";
        } else if (poiImage[a] == "Exit") {
          return "assets/symbols/exit.png";
        } else if (poiImage[a] == "Gates") {
          //TO BE CHANGED
          return "assets/symbols/postoffice.png";
        } else if (poiImage[a] == "FIDS") {
          //TO BE CHANGED
          return "assets/symbols/postoffice.png";
        } else if (poiImage[a] == "Lift") {
          return "assets/symbols/lift.png";
        } else if (poiImage[a] == "Lost and found") {
          return "assets/symbols/lostandfound.png";
        } else if (poiImage[a] == "Metro") {
          return "assets/symbols/metro.png";
        } else if (poiImage[a] == "Passport control") {
          return "assets/symbols/passport.png";
        } else if (poiImage[a] == "Charging") {
          return "assets/symbols/charging.png";
        } else if (poiImage[a] == "Prayer room") {
          return "assets/symbols/prayer.png";
        } else if (poiImage[a] == "security screening") {
          return "assets/symbols/security.png";
        } else if (poiImage[a] == "smoking room") {
          return "assets/symbols/smoking.png";
        } else if (poiImage[a] == "staircase") {
          return "assets/symbols/stairs.png";
        } else if (poiImage[a] == "toilet") {
          return "assets/symbols/charging.png";
        } else if (poiImage[a] == "train") {
          return "assets/symbols/train.png";
        } else if (poiImage[a] == "transit") {
          return "assets/symbols/transit.png";
        } else if (poiImage[a] == "drinking water") {
          //TO BE CHANGEd
          return "assets/symbols/charging.png";
        } else if (poiImage[a] == "emergency exit") {
          return "assets/symbols/exit.png";
        } else if (poiImage[a] == "medical") {
          return "assets/symbols/medical.png";
        } else if (poiImage[a] == "female toilet") {
          return "assets/symbols/femaletoilet.png";
        } else if (poiImage[a] == "male toilet") {
          return "assets/symbols/toilet.png";
        } else if (poiImage[a] == "disabled toilet") {
          return "assets/symbols/disabled.png";
        } else if (poiImage[a] == "Help desk") {
          return "assets/symbols/helpdesk.png";
        } else {
          return "assets/symbols/helpdesk.png";
          // return "assets/symbols/neww.png";
        }
      }

      controller.addSymbol(
        SymbolOptions(
            geometry: poisList[a],
            iconImage: iconReturn(),
            iconSize: 2.5,
            textField: poisName[a],
            textSize: 15,
            iconOffset: const Offset(0, -10)),
      );
    }

    // mapBoxController.onSymbolTapped.add(((argument) {
    //   print("aaunga $argument");
    // }));

    // mapBoxController.onSymbolTapped.add(tappedaFunction);

    // mapBoxController.onSymbolTapped.add(tappedaFunction);
  }

  @override
  Widget build(BuildContext context) {
    @override
    void didUpdateWidget(MyHome oldWidget) {
      super.didUpdateWidget(oldWidget);

      print('didUpdateWidget');
    }

    const Channel = MethodChannel("com.mapbox.mapboxglexample");
    const platform = MethodChannel("com.mapbox.mapboxglexample");

    platform.setMethodCallHandler((call) async {
      print("init state setMethodCallHandler ${call.arguments}");
      setState(() {
        // _initialCameraPosition =
        //     CameraPosition(target: convertToLatLng(), zoom: 17, tilt: 30.0);
      });
      ScaffoldMessenger.of(context).showSnackBar(
        SnackBar(
          content: Text(convertToLatLng().toString()),
        ),
      );
    });
    // setState(() {
    //   _initialCameraPosition =
    //       CameraPosition(target: convertToLatLng(), zoom: 17, tilt: 30.0);
    //   ScaffoldMessenger.of(context).showSnackBar(
    //     SnackBar(
    //       content: Text(widget.data),
    //     ),
    //   );
    // });
    double myHeight = MediaQuery.of(context).size.height / 3.8;
    double myBigHeight = MediaQuery.of(context).size.height - myHeight - 100;
    double width = MediaQuery.of(context).size.width;
    double height = MediaQuery.of(context).size.height;
    double btnPadding = 10.0;
    double btnSize = 25.0;
    double fontSize = 16.0;
    Future<void> shareRestro(String title, String location) async {
      await FlutterShare.share(
        title: title,
        text: location,
      );
    }

    return Scaffold(
        // floatingActionButton: FloatingActionButton(
        //   // child: Image.asset("name"),
        //   onPressed: () {
        //     Navigator.push(
        //       context,
        //       MaterialPageRoute(builder: (context) => const Direction()),
        //     );
        //   },
        // ),
        body: GestureDetector(
      onTap: () {
        FocusScope.of(context).requestFocus(FocusNode());
        // searchFocus.
      },
      child: finalBool && finalBool2
          ? const Center(child: CircularProgressIndicator())
          : SafeArea(
              child: SizedBox(
              width: width,
              height: height,
              // color: Colors.teal,
              child: Stack(
                children: [
                  SizedBox(
                    child: isLoading
                        ? Center(
                            child: Column(
                              mainAxisAlignment: MainAxisAlignment.center,
                              children: const [
                                CircularProgressIndicator(),
                                SizedBox(
                                  height: 20,
                                ),
                                Text("Loading POI's & IA Location")
                              ],
                            ),
                          )
                        : Stack(
                            children: [
                              SizedBox(
                                height: height - 100,
                                child: Stack(
                                  alignment: Alignment.bottomCenter,
                                  children: [
                                    SizedBox(
                                      height: height - 100,
                                      child: IndoorAtlasListener(
                                        name: 'insuide',
                                        onFloorplan: _onFloorPlan,
                                        onHeading: _onHeading,
                                        onLocation: _onLocation,
                                        onVenue: _onVenue,
                                        onOrientation: _onOrientationChanged,
                                        onStatus: _onStatus,
                                        onWayfindingRoute: _onWayfindingRoute,
                                        child: MapboxMap(
                                          tiltGesturesEnabled: true,
                                          accessToken:
                                              "sk.eyJ1IjoibWVycmlsbGdvbnNhbHZlcyIsImEiOiJja2l6eno3ZWk0ZnYxMnNsYng5azdxdjBiIn0.fkx2_7LZ7uq80mHYCuh46w",
                                          initialCameraPosition:
                                              _initialCameraPosition,
                                          onMapCreated: _onMapCreated,
                                          trackCameraPosition: true,
                                          onCameraTrackingChanged: (mode) {
                                            // print("mode.name ${mode}");
                                            // print("mode.name ${mode.name}");
                                          },

                                          onStyleLoadedCallback: () =>
                                              addSymbol(),
                                          // myLocationEnabled: true,
                                          myLocationTrackingMode:
                                              MyLocationTrackingMode
                                                  .TrackingGPS,
                                          // minMaxZoomPreference:
                                          //     const MinMaxZoomPreference(14, 17),
                                          // annotationOrder: [
                                          //   AnnotationType.symbol
                                          // ],
                                          styleString: kamalString,
                                        ),
                                      ),
                                    ),
                                    Container(
                                      margin: const EdgeInsets.only(
                                          left: 20, right: 20),
                                      padding: EdgeInsets.only(
                                          bottom: height * 0.275),
                                      child: Row(
                                        crossAxisAlignment:
                                            CrossAxisAlignment.end,
                                        mainAxisAlignment:
                                            MainAxisAlignment.spaceBetween,
                                        children: [
                                          GestureDetector(
                                            //USER LOCATION
                                            onTap: () {
                                              controller.animateCamera(
                                                  CameraUpdate.newCameraPosition(
                                                      const CameraPosition(
                                                          target: LatLng(
                                                              19.098519,
                                                              72.874318),
                                                          zoom: 20,
                                                          tilt: 30.0)
                                                      // CameraPosition(
                                                      //     target:
                                                      //         convertToLatLng())
                                                      ));
                                            },
                                            child: Container(
                                              padding:
                                                  EdgeInsets.all(btnPadding),
                                              decoration: BoxDecoration(
                                                  color: Colors.white,
                                                  borderRadius:
                                                      BorderRadius.circular(
                                                          10)),
                                              child: Image.asset(
                                                "assets/images/location.png",
                                                width: btnSize,
                                                height: btnSize,
                                              ),
                                            ),
                                          ),
                                          GestureDetector(
                                            onTap: () async {
                                              print("TAPPED ON SHARE");
                                              // shareRestro("Insuide Maps",
                                              //     "We'll share your location here");

                                              print("TAPPED BUTTON");
                                              try {
                                                print(
                                                    "SENDING DATA ${allPOIS!.map((poi) => poi.toMap()).toList()}");
                                                final poisMaps = allPOIS!
                                                    .map((poi) => poi.toMap())
                                                    .toList();
                                                await methodChannel
                                                    .invokeMethod(
                                                  'openAR',
                                                  [
                                                    selectedPoiForAR ??
                                                        allPOIS![0].id,
                                                    poisMaps,
                                                  ],
                                                );
                                              } on PlatformException catch (e) {
                                                log("${e.message}");
                                              }
                                            },
                                            child: Column(
                                              mainAxisSize: MainAxisSize.min,
                                              children: [
                                                Container(
                                                  padding: EdgeInsets.all(
                                                      btnPadding),
                                                  decoration: const BoxDecoration(
                                                      color: Colors.white,
                                                      borderRadius:
                                                          BorderRadius.only(
                                                              topLeft: Radius
                                                                  .circular(7),
                                                              topRight: Radius
                                                                  .circular(
                                                                      7))),
                                                  child: Image.asset(
                                                    "assets/images/navigate.png",
                                                    width: btnSize,
                                                    height: btnSize,
                                                  ),
                                                ),
                                                const SizedBox(
                                                  height: 1,
                                                ),
                                                GestureDetector(
                                                  onTap: () {
                                                    showModalBottomSheet<void>(
                                                      context: context,
                                                      backgroundColor:
                                                          Colors.transparent,
                                                      builder: (BuildContext
                                                          context) {
                                                        return Container(
                                                          height:
                                                              height * 0.345,
                                                          width: width,
                                                          decoration: const BoxDecoration(
                                                              color:
                                                                  Colors.white,
                                                              borderRadius: BorderRadius.only(
                                                                  topLeft: Radius
                                                                      .circular(
                                                                          32),
                                                                  topRight: Radius
                                                                      .circular(
                                                                          32))),
                                                          child: Padding(
                                                            padding:
                                                                const EdgeInsets
                                                                    .all(10.0),
                                                            child:
                                                                SingleChildScrollView(
                                                              child: Column(
                                                                crossAxisAlignment:
                                                                    CrossAxisAlignment
                                                                        .start,
                                                                children: [
                                                                  Align(
                                                                    alignment:
                                                                        Alignment
                                                                            .center,
                                                                    child:
                                                                        Container(
                                                                      width:
                                                                          width *
                                                                              0.2,
                                                                      height: 5,
                                                                      decoration: BoxDecoration(
                                                                          color: const Color(
                                                                              0xffEAEBED),
                                                                          borderRadius:
                                                                              BorderRadius.circular(10.0)),
                                                                    ),
                                                                  ),
                                                                  Padding(
                                                                    padding: const EdgeInsets
                                                                            .only(
                                                                        left:
                                                                            5),
                                                                    child:
                                                                        GestureDetector(
                                                                      onTap:
                                                                          () {
                                                                        Navigator.pop(
                                                                            context);
                                                                      },
                                                                      child: const Icon(
                                                                          Icons
                                                                              .close),
                                                                    ),
                                                                  ),
                                                                  const SizedBox(
                                                                      height:
                                                                          10),
                                                                  const Padding(
                                                                    padding: EdgeInsets
                                                                        .only(
                                                                            left:
                                                                                8),
                                                                    child: Text(
                                                                        "Terminal",
                                                                        style: TextStyle(
                                                                            fontWeight:
                                                                                FontWeight.bold,
                                                                            fontSize: 25)),
                                                                  ),
                                                                  TextButton(
                                                                      onPressed:
                                                                          () async {
                                                                        // final SharedPreferences
                                                                        //     sharedPreferences =
                                                                        //     await SharedPreferences.getInstance();
                                                                        // sharedPreferences.setDouble(
                                                                        //     'lat',
                                                                        //     19.092067);
                                                                        // sharedPreferences.setDouble(
                                                                        //     'long',
                                                                        //     72.853808);
                                                                        // sharedPreferences.setString(
                                                                        //     'styleString',
                                                                        //     'mapbox://styles/merrillgonsalves/cl5l2hq6w001o15nxfhzighuw');
                                                                        // sharedPreferences.setString(
                                                                        //     "level",
                                                                        //     "2");
                                                                        // sharedPreferences.setString(
                                                                        //     "terminal",
                                                                        //     "1");

                                                                        // Navigator.push(
                                                                        //   context,
                                                                        //   MaterialPageRoute(
                                                                        //       builder: (context) => const Loading(
                                                                        //             level: '2',
                                                                        //             terminal: '1',
                                                                        //           )),
                                                                        // );

                                                                        // controller
                                                                        //     .dispose();

                                                                        setState(
                                                                            () {
                                                                          // myTer =
                                                                          //     "1";
                                                                          // myLev =
                                                                          //     "2";
                                                                          kamalString =
                                                                              'mapbox://styles/merrillgonsalves/cl5ez27io005p14rz5aqp8234';
                                                                          controller.animateCamera(CameraUpdate.newCameraPosition(const CameraPosition(
                                                                              target: LatLng(19.093099, 72.856952),
                                                                              zoom: 17,
                                                                              tilt: 30.0)));
                                                                          level0active =
                                                                              true;

                                                                          level1active =
                                                                              false;
                                                                          level2active =
                                                                              false;
                                                                          level3active =
                                                                              false;
                                                                          level4active =
                                                                              false;
                                                                          isTer1 =
                                                                              true;
                                                                        });
                                                                        // fetchPois("1", "2");

                                                                        filterPOIs(
                                                                            "1",
                                                                            "0");

                                                                        // Navigator.pop(
                                                                        //     context);

                                                                        if (isTerminal2Selected) {
                                                                          setState(
                                                                              () {
                                                                            isTerminal2Selected =
                                                                                false;
                                                                          });
                                                                        }
                                                                        Navigator.pop(
                                                                            context);
                                                                      },
                                                                      child:
                                                                          Row(
                                                                        mainAxisAlignment:
                                                                            MainAxisAlignment.spaceBetween,
                                                                        children: [
                                                                          Text(
                                                                              "Terminal 1",
                                                                              style: !isTerminal2Selected ? const TextStyle(color: Colors.black, fontStyle: FontStyle.italic) : const TextStyle(color: Colors.black)),
                                                                          isTer1
                                                                              ? const Icon(
                                                                                  Icons.check,
                                                                                  color: Colors.black,
                                                                                )
                                                                              : Container()
                                                                        ],
                                                                      )),

                                                                  /* Terminal 2 Button */
                                                                  TextButton(
                                                                      onPressed:
                                                                          () async {
                                                                        // final SharedPreferences
                                                                        //     sharedPreferences =
                                                                        //     await SharedPreferences.getInstance();
                                                                        // sharedPreferences.setDouble(
                                                                        //     'lat',
                                                                        //     19.098519);
                                                                        // sharedPreferences.setDouble(
                                                                        //     'long',
                                                                        //     72.874318);
                                                                        // sharedPreferences.setString(
                                                                        //     'styleString',
                                                                        //     'mapbox://styles/merrillgonsalves/cl508fw8s000u15rsht67q9tx');
                                                                        // sharedPreferences.setString(
                                                                        //     "level",
                                                                        //     "4");
                                                                        // sharedPreferences.setString(
                                                                        //     "terminal",
                                                                        //     "2");

                                                                        setState(
                                                                            () {
                                                                          // myTer =
                                                                          //     "2";
                                                                          // myLev =
                                                                          //     "4";
                                                                          kamalString =
                                                                              'mapbox://styles/merrillgonsalves/cl508fw8s000u15rsht67q9tx';
                                                                          controller.animateCamera(CameraUpdate.newCameraPosition(const CameraPosition(
                                                                              target: LatLng(19.098519, 72.874318),
                                                                              zoom: 17,
                                                                              tilt: 30.0)));
                                                                          isTer1 =
                                                                              false;
                                                                        });
                                                                        // fetchPois("2", "4");

                                                                        filterPOIs(
                                                                            "2",
                                                                            "4");

                                                                        // Navigator.pop(
                                                                        //     context);

                                                                        // Navigator.push(
                                                                        //   context,
                                                                        //   MaterialPageRoute(
                                                                        //       builder: (context) => const Loading(
                                                                        //             level: '4',
                                                                        //             terminal: '2',
                                                                        //           )),
                                                                        // );

                                                                        // controller
                                                                        //     .dispose();

                                                                        if (isTerminal2Selected) {
                                                                          // await sharedPreferences.setBool(
                                                                          //     "isTerminal2Selected",
                                                                          //     false);
                                                                          // setState(
                                                                          //     () {
                                                                          //   isTerminal2Selected =
                                                                          //       false;
                                                                          // });
                                                                        } else {
                                                                          // await sharedPreferences.setBool(
                                                                          //     "isTerminal2Selected",
                                                                          //     true);
                                                                          setState(
                                                                              () {
                                                                            isTerminal2Selected =
                                                                                true;
                                                                            level0active =
                                                                                false;
                                                                            level1active =
                                                                                false;
                                                                            level2active =
                                                                                false;
                                                                            level3active =
                                                                                false;
                                                                            level4active =
                                                                                true;
                                                                          });
                                                                        }
                                                                        Navigator.pop(
                                                                            context);
                                                                      },
                                                                      child:
                                                                          Row(
                                                                        mainAxisAlignment:
                                                                            MainAxisAlignment.spaceBetween,
                                                                        children: [
                                                                          Text(
                                                                              "Terminal 2",
                                                                              style: isTerminal2Selected ? const TextStyle(color: Colors.black, fontStyle: FontStyle.italic) : const TextStyle(color: Colors.black)),
                                                                          isTerminal2Selected && !isTer1
                                                                              ? const Icon(
                                                                                  Icons.check,
                                                                                  color: Colors.black,
                                                                                )
                                                                              : Container()
                                                                        ],
                                                                      )),
                                                                ],
                                                              ),
                                                            ),
                                                          ),
                                                        );
                                                      },
                                                    );
                                                  },
                                                  child: Container(
                                                    padding: EdgeInsets.all(
                                                        btnPadding),
                                                    decoration: const BoxDecoration(
                                                        color: Colors.white,
                                                        borderRadius:
                                                            BorderRadius.only(
                                                                bottomLeft: Radius
                                                                    .circular(
                                                                        7),
                                                                bottomRight:
                                                                    Radius
                                                                        .circular(
                                                                            7))),
                                                    child: Image.asset(
                                                      "assets/images/terminal.png",
                                                      width: btnSize,
                                                      height: btnSize,
                                                    ),
                                                  ),
                                                ),
                                                const SizedBox(
                                                  height: 1,
                                                ),
                                                GestureDetector(
                                                  onTap: () {
                                                    showModalBottomSheet<void>(
                                                      context: context,
                                                      backgroundColor:
                                                          Colors.transparent,
                                                      builder: (BuildContext
                                                          context) {
                                                        return Container(
                                                          height:
                                                              height * 0.345,
                                                          width: width,
                                                          decoration: const BoxDecoration(
                                                              color:
                                                                  Colors.white,
                                                              borderRadius: BorderRadius.only(
                                                                  topLeft: Radius
                                                                      .circular(
                                                                          32),
                                                                  topRight: Radius
                                                                      .circular(
                                                                          32))),
                                                          child: Padding(
                                                            padding:
                                                                const EdgeInsets
                                                                    .all(10.0),
                                                            child:
                                                                SingleChildScrollView(
                                                              child: Column(
                                                                crossAxisAlignment:
                                                                    CrossAxisAlignment
                                                                        .start,
                                                                children: [
                                                                  Align(
                                                                    alignment:
                                                                        Alignment
                                                                            .center,
                                                                    child:
                                                                        Container(
                                                                      width:
                                                                          width *
                                                                              0.2,
                                                                      height: 5,
                                                                      decoration: BoxDecoration(
                                                                          color: const Color(
                                                                              0xffEAEBED),
                                                                          borderRadius:
                                                                              BorderRadius.circular(10.0)),
                                                                    ),
                                                                  ),
                                                                  Padding(
                                                                    padding: const EdgeInsets
                                                                            .only(
                                                                        left:
                                                                            5),
                                                                    child:
                                                                        GestureDetector(
                                                                      onTap:
                                                                          () {
                                                                        Navigator.pop(
                                                                            context);
                                                                      },
                                                                      child: const Icon(
                                                                          Icons
                                                                              .close),
                                                                    ),
                                                                  ),
                                                                  const SizedBox(
                                                                      height:
                                                                          10),
                                                                  const Padding(
                                                                    padding: EdgeInsets
                                                                        .only(
                                                                            left:
                                                                                8),
                                                                    child: Text(
                                                                        "Level",
                                                                        style: TextStyle(
                                                                            fontWeight:
                                                                                FontWeight.bold,
                                                                            fontSize: 25)),
                                                                  ),
                                                                  Visibility(
                                                                    visible:
                                                                        !isTerminal2Selected,
                                                                    child: TextButton(
                                                                        onPressed: () async {
                                                                          // final SharedPreferences
                                                                          //     sharedPreferences =
                                                                          //     await SharedPreferences.getInstance();
                                                                          // sharedPreferences.setDouble('lat',
                                                                          //     19.093099);
                                                                          // sharedPreferences.setDouble('long',
                                                                          //     72.856952);
                                                                          // sharedPreferences.setString('styleString',
                                                                          //     'mapbox://styles/merrillgonsalves/cl5ez27io005p14rz5aqp8234');
                                                                          // sharedPreferences.setString("level",
                                                                          //     "0");
                                                                          // sharedPreferences.setString("terminal",
                                                                          //     "1");
                                                                          // sharedPreferences.setBool("level0active",
                                                                          //     true);
                                                                          // sharedPreferences.setBool("level1active",
                                                                          //     false);
                                                                          // sharedPreferences.setBool("level2active",
                                                                          //     false);
                                                                          // sharedPreferences.setBool("level3active",
                                                                          //     false);
                                                                          // sharedPreferences.setBool("level4active",
                                                                          //     false);
                                                                          // Navigator.pushReplacement(
                                                                          //   context,
                                                                          //   MaterialPageRoute(builder: (context) => const Loading()),
                                                                          // );
                                                                          setState(
                                                                              () {
                                                                            level0active =
                                                                                true;
                                                                            level1active =
                                                                                false;
                                                                            level2active =
                                                                                false;
                                                                            level3active =
                                                                                false;
                                                                            level4active =
                                                                                false;
                                                                            kamalString =
                                                                                'mapbox://styles/merrillgonsalves/cl5ez27io005p14rz5aqp8234';
                                                                            controller.animateCamera(CameraUpdate.newCameraPosition(const CameraPosition(
                                                                                target: LatLng(19.093099, 72.856952),
                                                                                zoom: 17,
                                                                                tilt: 30.0)));
                                                                          });
                                                                          // fetchPois("1", "0");

                                                                          filterPOIs(
                                                                              "1",
                                                                              "0");

                                                                          Navigator.pop(
                                                                              context);
                                                                          // controller.dispose();
                                                                        },
                                                                        child: Row(
                                                                          mainAxisAlignment:
                                                                              MainAxisAlignment.spaceBetween,
                                                                          children: [
                                                                            Text(
                                                                              "Level 0",
                                                                              style: level0active ? const TextStyle(color: Colors.black, fontStyle: FontStyle.italic) : const TextStyle(color: Colors.black),
                                                                            ),
                                                                            level0active
                                                                                ? const Icon(
                                                                                    Icons.check,
                                                                                    color: Colors.black,
                                                                                  )
                                                                                : Container()
                                                                          ],
                                                                        )),
                                                                  ),
                                                                  TextButton(
                                                                      onPressed:
                                                                          () async {
                                                                        // final SharedPreferences
                                                                        //     sharedPreferences =
                                                                        //     await SharedPreferences.getInstance();
                                                                        // bool
                                                                        //     _myCheckBool =
                                                                        //     sharedPreferences.getBool("isTerminal2Selected") ?? true;
                                                                        // if (_myCheckBool) {
                                                                        //   sharedPreferences.setDouble('lat',
                                                                        //       19.099474);
                                                                        //   sharedPreferences.setDouble('long',
                                                                        //       72.874330);
                                                                        //   sharedPreferences.setString('styleString',
                                                                        //       'mapbox://styles/merrillgonsalves/cl5ez2e9l000j14r0y08curhk');

                                                                        //   if (isTerminal2Selected!) {
                                                                        //     sharedPreferences.setString("level", "1");
                                                                        //     sharedPreferences.setString("terminal", "2");
                                                                        //   } else {
                                                                        //     sharedPreferences.setString("level", "1");
                                                                        //     sharedPreferences.setString("terminal", "1");
                                                                        //   }

                                                                        //   controller.dispose();
                                                                        // } else {
                                                                        //   sharedPreferences.setDouble('lat',
                                                                        //       19.092141);
                                                                        //   sharedPreferences.setDouble('long',
                                                                        //       72.855159);
                                                                        //   sharedPreferences.setString('styleString',
                                                                        //       'mapbox://styles/merrillgonsalves/cl5ez2lht002214s0ow0ghr8z');
                                                                        // }
                                                                        // Navigator
                                                                        //     .push(
                                                                        //   context,
                                                                        //   MaterialPageRoute(builder: (context) => const Loading()),
                                                                        // );
                                                                        // sharedPreferences.setBool(
                                                                        //     "level0active",
                                                                        //     false);
                                                                        // sharedPreferences.setBool(
                                                                        //     "level1active",
                                                                        //     true);
                                                                        // sharedPreferences.setBool(
                                                                        //     "level2active",
                                                                        //     false);
                                                                        // sharedPreferences.setBool(
                                                                        //     "level3active",
                                                                        //     false);
                                                                        // sharedPreferences.setBool(
                                                                        //     "level4active",
                                                                        //     false);

                                                                        if (isTerminal2Selected) {
                                                                          setState(
                                                                              () {
                                                                            level0active =
                                                                                false;
                                                                            level1active =
                                                                                true;
                                                                            level2active =
                                                                                false;
                                                                            level3active =
                                                                                false;
                                                                            level4active =
                                                                                false;
                                                                            kamalString =
                                                                                'mapbox://styles/merrillgonsalves/cl5ez2e9l000j14r0y08curhk';
                                                                            controller.animateCamera(CameraUpdate.newCameraPosition(const CameraPosition(
                                                                                target: LatLng(19.099474, 72.874330),
                                                                                zoom: 17,
                                                                                tilt: 30.0)));
                                                                          });
                                                                          // fetchPois("2", "1");

                                                                          filterPOIs(
                                                                              "2",
                                                                              "1");
                                                                        } else {
                                                                          setState(
                                                                              () {
                                                                            level0active =
                                                                                false;
                                                                            level1active =
                                                                                true;
                                                                            level2active =
                                                                                false;
                                                                            level3active =
                                                                                false;
                                                                            level4active =
                                                                                false;
                                                                            kamalString =
                                                                                'mapbox://styles/merrillgonsalves/cl5ez2lht002214s0ow0ghr8z';
                                                                            controller.animateCamera(CameraUpdate.newCameraPosition(const CameraPosition(
                                                                                target: LatLng(19.092141, 72.855159),
                                                                                zoom: 17,
                                                                                tilt: 30.0)));
                                                                          });
                                                                          // fetchPois("1", "1");

                                                                          filterPOIs(
                                                                              "1",
                                                                              "1");
                                                                        }

                                                                        Navigator.pop(
                                                                            context);
                                                                        print(
                                                                            "TAPPED IN LEVEL 1");
                                                                      },
                                                                      child:
                                                                          Row(
                                                                        mainAxisAlignment:
                                                                            MainAxisAlignment.spaceBetween,
                                                                        children: [
                                                                          Text(
                                                                            "Level 1",
                                                                            style: level1active
                                                                                ? const TextStyle(color: Colors.black, fontStyle: FontStyle.italic)
                                                                                : const TextStyle(color: Colors.black),
                                                                          ),
                                                                          level1active
                                                                              ? const Icon(
                                                                                  Icons.check,
                                                                                  color: Colors.black,
                                                                                )
                                                                              : Container()
                                                                        ],
                                                                      )),
                                                                  TextButton(
                                                                      onPressed:
                                                                          () async {
                                                                        // final SharedPreferences
                                                                        //     sharedPreferences =
                                                                        //     await SharedPreferences.getInstance();
                                                                        // bool
                                                                        //     myCheckBool =
                                                                        //     sharedPreferences.getBool("isTerminal2Selected") ?? true;
                                                                        // if (myCheckBool) {
                                                                        //   sharedPreferences.setDouble('lat',
                                                                        //       19.098588);
                                                                        //   sharedPreferences.setDouble('long',
                                                                        //       72.874341);
                                                                        //   sharedPreferences.setString('styleString',
                                                                        //       'mapbox://styles/merrillgonsalves/cl5ez205n002h14pvay28t8iz');
                                                                        //   Navigator.pushReplacement(
                                                                        //     context,
                                                                        //     MaterialPageRoute(builder: (context) => const Loading()),
                                                                        //   );
                                                                        //   controller.dispose();
                                                                        // } else {
                                                                        //   sharedPreferences.setDouble('lat',
                                                                        //       19.092067);
                                                                        //   sharedPreferences.setDouble('long',
                                                                        //       72.853808);
                                                                        //   sharedPreferences.setString('styleString',
                                                                        //       'mapbox://styles/merrillgonsalves/cl5l2hq6w001o15nxfhzighuw');

                                                                        //   if (isTerminal2Selected!) {
                                                                        //     sharedPreferences.setString("level", "2");
                                                                        //     sharedPreferences.setString("terminal", "2");
                                                                        //   } else {
                                                                        //     sharedPreferences.setString("level", "2");
                                                                        //     sharedPreferences.setString("terminal", "1");
                                                                        //   }

                                                                        //   Navigator.pushReplacement(
                                                                        //     context,
                                                                        //     MaterialPageRoute(builder: (context) => const Loading()),
                                                                        //   );
                                                                        //   controller.dispose();
                                                                        // }
                                                                        // sharedPreferences.setBool(
                                                                        //     "level0active",
                                                                        //     false);
                                                                        // sharedPreferences.setBool(
                                                                        //     "level1active",
                                                                        //     false);
                                                                        // sharedPreferences.setBool(
                                                                        //     "level2active",
                                                                        //     true);
                                                                        // sharedPreferences.setBool(
                                                                        //     "level3active",
                                                                        //     false);
                                                                        // sharedPreferences.setBool(
                                                                        //     "level4active",
                                                                        //     false);
                                                                        // Navigator.pop(
                                                                        //     context);
                                                                        print(
                                                                            "TAPPED IN LEVEL 2");
                                                                        if (isTerminal2Selected) {
                                                                          setState(
                                                                              () {
                                                                            level0active =
                                                                                false;
                                                                            level1active =
                                                                                false;
                                                                            level2active =
                                                                                true;
                                                                            level3active =
                                                                                false;
                                                                            level4active =
                                                                                false;
                                                                            kamalString =
                                                                                'mapbox://styles/merrillgonsalves/cl5ez205n002h14pvay28t8iz';
                                                                            controller.animateCamera(CameraUpdate.newCameraPosition(const CameraPosition(
                                                                                target: LatLng(19.098588, 72.874341),
                                                                                zoom: 17,
                                                                                tilt: 30.0)));
                                                                          });
                                                                          // fetchPois("2", "2");

                                                                          filterPOIs(
                                                                              "2",
                                                                              "2");
                                                                        } else {
                                                                          setState(
                                                                              () {
                                                                            level0active =
                                                                                false;
                                                                            level1active =
                                                                                false;
                                                                            level2active =
                                                                                true;
                                                                            level3active =
                                                                                false;
                                                                            level4active =
                                                                                false;
                                                                            kamalString =
                                                                                'mapbox://styles/merrillgonsalves/cl5l2hq6w001o15nxfhzighuw';
                                                                            controller.animateCamera(CameraUpdate.newCameraPosition(const CameraPosition(
                                                                                target: LatLng(19.092067, 72.853808),
                                                                                zoom: 17,
                                                                                tilt: 30.0)));
                                                                          });
                                                                          // fetchPois("1", "2");
                                                                          filterPOIs(
                                                                              "1",
                                                                              "2");
                                                                        }

                                                                        Navigator.pop(
                                                                            context);
                                                                      },
                                                                      child:
                                                                          Row(
                                                                        mainAxisAlignment:
                                                                            MainAxisAlignment.spaceBetween,
                                                                        children: [
                                                                          Text(
                                                                            "Level 2",
                                                                            style: level2active
                                                                                ? const TextStyle(color: Colors.black, fontStyle: FontStyle.italic)
                                                                                : const TextStyle(color: Colors.black),
                                                                          ),
                                                                          level2active
                                                                              ? const Icon(
                                                                                  Icons.check,
                                                                                  color: Colors.black,
                                                                                )
                                                                              : Container()
                                                                        ],
                                                                      )),
                                                                  Visibility(
                                                                    visible:
                                                                        isTerminal2Selected,
                                                                    child: TextButton(
                                                                        onPressed: () async {
                                                                          // final SharedPreferences
                                                                          //     sharedPreferences =
                                                                          //     await SharedPreferences.getInstance();
                                                                          // sharedPreferences.setDouble('lat',
                                                                          //     19.096827);
                                                                          // sharedPreferences.setDouble('long',
                                                                          //     72.874386);
                                                                          // sharedPreferences.setString('styleString',
                                                                          //     'mapbox://styles/merrillgonsalves/cl5c9c84e006o14nu2a8sny58');
                                                                          // sharedPreferences.setString("level",
                                                                          //     "3");
                                                                          // sharedPreferences.setString("terminal",
                                                                          //     "2");
                                                                          // Navigator.pushReplacement(
                                                                          //   context,
                                                                          //   MaterialPageRoute(builder: (context) => const Loading()),
                                                                          // );
                                                                          // sharedPreferences.setBool("level0active",
                                                                          //     false);
                                                                          // sharedPreferences.setBool("level1active",
                                                                          //     false);
                                                                          // sharedPreferences.setBool("level2active",
                                                                          //     false);
                                                                          // sharedPreferences.setBool("level3active",
                                                                          //     true);
                                                                          // sharedPreferences.setBool("level4active",
                                                                          //     false);
                                                                          // controller.dispose();
                                                                          setState(
                                                                              () {
                                                                            level0active =
                                                                                false;
                                                                            level1active =
                                                                                false;
                                                                            level2active =
                                                                                false;
                                                                            level3active =
                                                                                true;
                                                                            level4active =
                                                                                false;
                                                                            kamalString =
                                                                                'mapbox://styles/merrillgonsalves/cl5c9c84e006o14nu2a8sny58';
                                                                            controller.animateCamera(CameraUpdate.newCameraPosition(const CameraPosition(
                                                                                target: LatLng(19.096827, 72.874386),
                                                                                zoom: 17,
                                                                                tilt: 30.0)));
                                                                          });
                                                                          // fetchPois("2", "3");
                                                                          filterPOIs(
                                                                              "2",
                                                                              "3");
                                                                          Navigator.pop(
                                                                              context);
                                                                          // controller.dispose();
                                                                        },
                                                                        child: Row(
                                                                          mainAxisAlignment:
                                                                              MainAxisAlignment.spaceBetween,
                                                                          children: [
                                                                            Text(
                                                                              "Level 3",
                                                                              style: level3active ? const TextStyle(color: Colors.black, fontStyle: FontStyle.italic) : const TextStyle(color: Colors.black),
                                                                            ),
                                                                            level3active
                                                                                ? const Icon(
                                                                                    Icons.check,
                                                                                    color: Colors.black,
                                                                                  )
                                                                                : Container()
                                                                          ],
                                                                        )),
                                                                  ),
                                                                  Visibility(
                                                                    visible:
                                                                        isTerminal2Selected,
                                                                    child: TextButton(
                                                                        onPressed: () async {
                                                                          // final SharedPreferences
                                                                          //     sharedPreferences =
                                                                          //     await SharedPreferences.getInstance();
                                                                          // sharedPreferences.setDouble('lat',
                                                                          //     19.098519);
                                                                          // sharedPreferences.setDouble('long',
                                                                          //     72.874318);
                                                                          // sharedPreferences.setString('styleString',
                                                                          //     'mapbox://styles/merrillgonsalves/cl508fw8s000u15rsht67q9tx');
                                                                          // sharedPreferences.setString("level",
                                                                          //     "4");
                                                                          // sharedPreferences.setString("terminal",
                                                                          //     "2");
                                                                          // sharedPreferences.setBool("level0active",
                                                                          //     false);
                                                                          // sharedPreferences.setBool("level1active",
                                                                          //     false);
                                                                          // sharedPreferences.setBool("level2active",
                                                                          //     false);
                                                                          // sharedPreferences.setBool("level3active",
                                                                          //     false);
                                                                          // sharedPreferences.setBool("level4active",
                                                                          //     true);

                                                                          // Navigator.pushReplacement(
                                                                          //   context,
                                                                          //   MaterialPageRoute(builder: (context) => const Loading()),
                                                                          // );
                                                                          // controller.dispose();
                                                                          setState(
                                                                              () {
                                                                            level0active =
                                                                                false;
                                                                            level1active =
                                                                                false;
                                                                            level2active =
                                                                                false;
                                                                            level3active =
                                                                                false;
                                                                            level4active =
                                                                                true;
                                                                            kamalString =
                                                                                'mapbox://styles/merrillgonsalves/cl508fw8s000u15rsht67q9tx';
                                                                            controller.animateCamera(CameraUpdate.newCameraPosition(const CameraPosition(
                                                                                target: LatLng(19.098519, 72.874318),
                                                                                zoom: 17,
                                                                                tilt: 30.0)));
                                                                          });
                                                                          // fetchPois("2", "4");
                                                                          filterPOIs(
                                                                              "2",
                                                                              "4");
                                                                          Navigator.pop(
                                                                              context);
                                                                        },
                                                                        child: Row(
                                                                          mainAxisAlignment:
                                                                              MainAxisAlignment.spaceBetween,
                                                                          children: [
                                                                            Text(
                                                                              "Level 4",
                                                                              style: level4active ? const TextStyle(color: Colors.black, fontStyle: FontStyle.italic) : const TextStyle(color: Colors.black),
                                                                            ),
                                                                            level4active
                                                                                ? const Icon(
                                                                                    Icons.check,
                                                                                    color: Colors.black,
                                                                                  )
                                                                                : Container()
                                                                          ],
                                                                        )),
                                                                  ),
                                                                ],
                                                              ),
                                                            ),
                                                          ),
                                                        );
                                                      },
                                                    );
                                                  },
                                                  child: Container(
                                                    padding: EdgeInsets.all(
                                                        btnPadding),
                                                    decoration: const BoxDecoration(
                                                        color: Colors.white,
                                                        borderRadius:
                                                            BorderRadius.only(
                                                                topLeft: Radius
                                                                    .circular(
                                                                        7),
                                                                topRight: Radius
                                                                    .circular(
                                                                        7))),
                                                    child: Image.asset(
                                                      "assets/images/layers.png",
                                                      width: btnSize,
                                                      height: btnSize,
                                                    ),
                                                  ),
                                                ),
                                              ],
                                            ),
                                          ),
                                        ],
                                      ),
                                    ),
                                  ],
                                ),
                              ),
                              // if (!isPoiTapped)
                              BlocConsumer<MyhomeBloc, MyhomeState>(
                                  listener: (context, state) {},
                                  builder: (context, state) {
                                    if (state is FirstSheetDisabled) {
                                      return Container();
                                    } else {
                                      return DraggableScrollableSheet(
                                          initialChildSize: minSize,
                                          minChildSize: minSize,
                                          maxChildSize: 1,
                                          snap: true,
                                          snapSizes: [minSize, 1],
                                          controller: dragController,
                                          builder: (BuildContext context,
                                              scrollSheetController) {
                                            return Container(
                                                decoration: const BoxDecoration(
                                                    boxShadow: <BoxShadow>[
                                                      BoxShadow(
                                                          color: Colors.black54,
                                                          blurRadius: 15.0,
                                                          offset:
                                                              Offset(0.0, 0.55))
                                                    ],
                                                    color: Colors.white,
                                                    borderRadius:
                                                        BorderRadius.only(
                                                      topLeft:
                                                          Radius.circular(32.0),
                                                      topRight:
                                                          Radius.circular(32.0),
                                                    )),
                                                child: ListView.builder(
                                                    // keyboardDismissBehavior: ScrollViewKeyboardDismissBehavior.onDrag,
                                                    padding: EdgeInsets.zero,
                                                    physics:
                                                        const ClampingScrollPhysics(),
                                                    controller:
                                                        scrollSheetController,
                                                    itemCount: 1,
                                                    itemBuilder:
                                                        (BuildContext context,
                                                            int index) {
                                                      return Column(
                                                        children: [
                                                          const SizedBox(
                                                              height: 8),
                                                          Container(
                                                            width: width * 0.2,
                                                            height: 5,
                                                            decoration: BoxDecoration(
                                                                color: const Color(
                                                                    0xffEAEBED),
                                                                borderRadius:
                                                                    BorderRadius
                                                                        .circular(
                                                                            10.0)),
                                                          ),
                                                          const SizedBox(
                                                              height: 15),
                                                          Container(
                                                            margin:
                                                                const EdgeInsets
                                                                        .symmetric(
                                                                    horizontal:
                                                                        20),
                                                            padding:
                                                                const EdgeInsets
                                                                        .symmetric(
                                                                    vertical:
                                                                        0),
                                                            decoration: BoxDecoration(
                                                                color: const Color(
                                                                    0xffEAEBED),
                                                                borderRadius:
                                                                    BorderRadius
                                                                        .circular(
                                                                            40)),
                                                            child:
                                                                TextFormField(
                                                              scrollPadding:
                                                                  EdgeInsets
                                                                      .zero,
                                                              decoration:
                                                                  InputDecoration(
                                                                // fillColor: Color(0xffEAEBED),
                                                                isDense: true,
                                                                contentPadding:
                                                                    const EdgeInsets
                                                                            .all(
                                                                        0.0),
                                                                prefixIcon: Icon(
                                                                    Icons
                                                                        .search,
                                                                    size:
                                                                        btnSize,
                                                                    color: const Color(
                                                                        0xFF555555)),
                                                                suffixIcon: canClose
                                                                    ? GestureDetector(
                                                                        onTap:
                                                                            () {
                                                                          searchTextController.text =
                                                                              "";
                                                                          searchList
                                                                              .clear();
                                                                          searchTextController
                                                                              .notifyListeners();
                                                                        },
                                                                        child:
                                                                            Icon(
                                                                          Icons
                                                                              .close,
                                                                          size: btnSize +
                                                                              5,
                                                                          color:
                                                                              const Color(0xFF555555),
                                                                        ),
                                                                      )
                                                                    : GestureDetector(
                                                                        onTap:
                                                                            () {
                                                                          Navigator
                                                                              .push(
                                                                            context,
                                                                            MaterialPageRoute(
                                                                                builder: (context) => ToDirection(
                                                                                      kamalString: kamalString!,
                                                                                    )),
                                                                          );
                                                                        },
                                                                        child:
                                                                            Icon(
                                                                          Icons
                                                                              .directions,
                                                                          size: btnSize +
                                                                              5,
                                                                          color:
                                                                              const Color(0xFF555555),
                                                                        ),
                                                                      ),
                                                                hintText:
                                                                    "Search",
                                                                hintStyle: const TextStyle(
                                                                    fontWeight:
                                                                        FontWeight
                                                                            .bold,
                                                                    fontSize:
                                                                        15),
                                                                border: OutlineInputBorder(
                                                                    borderRadius:
                                                                        BorderRadius.circular(
                                                                            40),
                                                                    borderSide:
                                                                        const BorderSide(
                                                                            color:
                                                                                Color(0xffEAEBED))),
                                                                disabledBorder: OutlineInputBorder(
                                                                    borderRadius:
                                                                        BorderRadius.circular(
                                                                            40),
                                                                    borderSide:
                                                                        const BorderSide(
                                                                            color:
                                                                                Color(0xffEAEBED))),
                                                                enabledBorder: OutlineInputBorder(
                                                                    borderRadius:
                                                                        BorderRadius.circular(
                                                                            40),
                                                                    borderSide:
                                                                        const BorderSide(
                                                                            color:
                                                                                Color(0xffEAEBED))),
                                                                focusedBorder: OutlineInputBorder(
                                                                    borderRadius:
                                                                        BorderRadius.circular(
                                                                            40),
                                                                    borderSide:
                                                                        const BorderSide(
                                                                            color:
                                                                                Color(0xffEAEBED))),
                                                              ),
                                                              // onTap: () {
                                                              //   readOnly = !readOnly;
                                                              //   setState(() {});
                                                              // },

                                                              // initialValue:
                                                              //     searchController.text,

                                                              onChanged:
                                                                  (text) {
                                                                print(
                                                                    ">>>>>   OnChange Search   <<<<<");
                                                                if (text
                                                                    .isNotEmpty) {
                                                                  searchList
                                                                      .clear();
                                                                  for (int i =
                                                                          0;
                                                                      i <
                                                                          dataPois
                                                                              .length;
                                                                      i++) {
                                                                    Datum d =
                                                                        dataPois[
                                                                            i];

                                                                    if (d.category.toString().toLowerCase().contains(text) ||
                                                                        d.subcategory
                                                                            .toString()
                                                                            .toLowerCase()
                                                                            .contains(
                                                                                text) ||
                                                                        d
                                                                            .poiMultilingual!
                                                                            .en!
                                                                            .name
                                                                            .toString()
                                                                            .toLowerCase()
                                                                            .contains(text)) {
                                                                      searchList
                                                                          .add(
                                                                              d);
                                                                    }
                                                                  }
                                                                } else {
                                                                  searchList
                                                                      .clear();
                                                                }
                                                                setState(() {});
                                                              },
                                                              onTap: () {
                                                                dragController.animateTo(1,
                                                                    duration: const Duration(
                                                                        milliseconds:
                                                                            500),
                                                                    curve: Curves
                                                                        .ease);
                                                              },

                                                              focusNode:
                                                                  searchFocus,
                                                              controller:
                                                                  searchTextController,
                                                            ),
                                                          ),
                                                          Stack(
                                                            children: [
                                                              Column(
                                                                mainAxisSize:
                                                                    MainAxisSize
                                                                        .min,
                                                                children: [
                                                                  const SizedBox(
                                                                      height:
                                                                          10),
                                                                  SizedBox(
                                                                    child:
                                                                        SingleChildScrollView(
                                                                      padding: const EdgeInsets
                                                                              .symmetric(
                                                                          horizontal:
                                                                              20),
                                                                      child:
                                                                          Column(
                                                                        mainAxisAlignment:
                                                                            MainAxisAlignment.start,
                                                                        crossAxisAlignment:
                                                                            CrossAxisAlignment.start,
                                                                        children: [
                                                                          // SizedBox(height: 5),
                                                                          Text(
                                                                            "Explore",
                                                                            style:
                                                                                TextStyle(fontSize: fontSize, fontStyle: FontStyle.italic),
                                                                          ),
                                                                          const SizedBox(
                                                                              height: 15),
                                                                          Row(
                                                                              mainAxisAlignment: MainAxisAlignment.spaceAround,
                                                                              children: [
                                                                                Column(
                                                                                  mainAxisAlignment: MainAxisAlignment.start,
                                                                                  crossAxisAlignment: CrossAxisAlignment.start,
                                                                                  children: [
                                                                                    GestureDetector(
                                                                                      onTap: () {
                                                                                        Navigator.push(
                                                                                          context,
                                                                                          MaterialPageRoute(
                                                                                              builder: (context) => const FilterData(
                                                                                                    searchData: 'restaurant',
                                                                                                  )),
                                                                                        );
                                                                                      },
                                                                                      child: Row(
                                                                                        mainAxisAlignment: MainAxisAlignment.spaceBetween,
                                                                                        children: [
                                                                                          Image.asset(
                                                                                            // "assets/symbols/Oval.png",
                                                                                            "assets/images/restro2.png",
                                                                                            // "assets/symbols/neww.png",
                                                                                            height: 30,
                                                                                            width: 30,
                                                                                          ),
                                                                                          const SizedBox(width: 10),
                                                                                          Text(
                                                                                            "Restaurants",
                                                                                            style: TextStyle(fontSize: fontSize),
                                                                                          )
                                                                                        ],
                                                                                      ),
                                                                                    ),
                                                                                    const SizedBox(
                                                                                      height: 15,
                                                                                    ),
                                                                                    GestureDetector(
                                                                                      onTap: () {
                                                                                        Navigator.push(
                                                                                          context,
                                                                                          MaterialPageRoute(
                                                                                              builder: (context) => const FilterData(
                                                                                                    searchData: 'shopping',
                                                                                                  )),
                                                                                        );
                                                                                      },
                                                                                      child: Row(
                                                                                        children: [
                                                                                          Image.asset(
                                                                                            "assets/images/shopping.png",
                                                                                            height: 35,
                                                                                            width: 35,
                                                                                          ),
                                                                                          const SizedBox(width: 10),
                                                                                          Text(
                                                                                            "Shopping",
                                                                                            style: TextStyle(fontSize: fontSize),
                                                                                          )
                                                                                        ],
                                                                                      ),
                                                                                    )
                                                                                  ],
                                                                                ),
                                                                                Column(
                                                                                  crossAxisAlignment: CrossAxisAlignment.start,
                                                                                  children: [
                                                                                    GestureDetector(
                                                                                      onTap: () {
                                                                                        Navigator.push(
                                                                                          context,
                                                                                          MaterialPageRoute(
                                                                                              builder: (context) => const FilterData(
                                                                                                    searchData: 'service',
                                                                                                  )),
                                                                                        );
                                                                                      },
                                                                                      child: Row(
                                                                                        children: [
                                                                                          Image.asset(
                                                                                            "assets/images/facilities.png",
                                                                                            height: 35,
                                                                                            width: 35,
                                                                                          ),
                                                                                          const SizedBox(width: 10),
                                                                                          Text(
                                                                                            "Facilities",
                                                                                            style: TextStyle(fontSize: fontSize),
                                                                                          )
                                                                                        ],
                                                                                      ),
                                                                                    ),
                                                                                    const SizedBox(
                                                                                      height: 15,
                                                                                    ),
                                                                                    GestureDetector(
                                                                                      onTap: () {
                                                                                        Navigator.push(
                                                                                          context,
                                                                                          MaterialPageRoute(
                                                                                              builder: (context) => const FilterData(
                                                                                                    searchData: 'utilities',
                                                                                                  )),
                                                                                        );
                                                                                      },
                                                                                      child: Row(
                                                                                        children: [
                                                                                          Image.asset(
                                                                                            "assets/images/utilities.png",
                                                                                            height: 35,
                                                                                            width: 35,
                                                                                          ),
                                                                                          const SizedBox(width: 10),
                                                                                          Text(
                                                                                            "Utilities",
                                                                                            style: TextStyle(fontSize: fontSize),
                                                                                          )
                                                                                        ],
                                                                                      ),
                                                                                    )
                                                                                  ],
                                                                                )
                                                                              ]),
                                                                          const SizedBox(
                                                                            height:
                                                                                20,
                                                                          ),
                                                                          Text(
                                                                            "Recent Searches",
                                                                            style:
                                                                                TextStyle(fontSize: fontSize, fontStyle: FontStyle.italic),
                                                                          ),
                                                                          const SizedBox(
                                                                            height:
                                                                                10,
                                                                          ),
                                                                          SizedBox(
                                                                            height:
                                                                                500,
                                                                            child:
                                                                                ListView.builder(
                                                                              shrinkWrap: true,
                                                                              itemCount: recentSearchName.length,
                                                                              itemBuilder: (context, index) {
                                                                                return Column(
                                                                                  children: [
                                                                                    GestureDetector(
                                                                                      onTap: () {
                                                                                        Navigator.push(
                                                                                          context,
                                                                                          MaterialPageRoute(
                                                                                              builder: (context) => PoiInfo(
                                                                                                    geo: recentSearchGeo[index],
                                                                                                    poiName: recentSearchName[index],
                                                                                                    iconImage: "assets/images/restro2.png",
                                                                                                  )),
                                                                                        );
                                                                                      },
                                                                                      child: searchItem(fontSize, recentSearchName[index], ""),
                                                                                    ),
                                                                                    const SizedBox(
                                                                                      height: 15,
                                                                                    ),
                                                                                  ],
                                                                                );
                                                                              },
                                                                            ),
                                                                          ),
                                                                          // searchItem(
                                                                          //     fontSize,
                                                                          //     "Baker Street",
                                                                          //     "Level 4, Security Hold Area"),
                                                                          // const SizedBox(
                                                                          //   height: 15,
                                                                          // ),
                                                                          // searchItem(
                                                                          //     fontSize,
                                                                          //     "Baker Street",
                                                                          //     "Level 4, Security Hold Area"),

                                                                          // const SizedBox(
                                                                          //   height: 15,
                                                                          // ),
                                                                          // searchItem(
                                                                          //     fontSize,
                                                                          //     "Baker Street",
                                                                          //     "Level 4, Security Hold Area"),
                                                                          // const SizedBox(
                                                                          //   height: 15,
                                                                          // ),
                                                                          // searchItem(
                                                                          //     fontSize,
                                                                          //     "Baker Street",
                                                                          //     "Level 4, Security Hold Area"),
                                                                          // const SizedBox(
                                                                          //   height: 15,
                                                                          // ),
                                                                          // searchItem(
                                                                          //     fontSize,
                                                                          //     "Baker Street",
                                                                          //     "Level 4, Security Hold Area"),
                                                                          // const SizedBox(
                                                                          //   height: 15,
                                                                          // ),
                                                                          // searchItem(
                                                                          //     fontSize,
                                                                          //     "Baker Street",
                                                                          //     "Level 4, Security Hold Area"),
                                                                          // const SizedBox(
                                                                          //   height: 15,
                                                                          // ),
                                                                          // searchItem(
                                                                          //     fontSize,
                                                                          //     "Baker Street",
                                                                          //     "Level 4, Security Hold Area"),
                                                                          const SizedBox(
                                                                            height:
                                                                                15,
                                                                          ),
                                                                        ],
                                                                      ),
                                                                    ),
                                                                  ),
                                                                ],
                                                              ),
                                                              (searchList
                                                                      .isNotEmpty)
                                                                  ? Container(
                                                                      // heigh:t double.minPositive,
                                                                      height:
                                                                          height *
                                                                              0.87,
                                                                      color: Colors
                                                                          .white,
                                                                      child: ListView.builder(
                                                                          shrinkWrap: true,
                                                                          itemCount: searchList.length,
                                                                          itemBuilder: (BuildContext context, int index) {
                                                                            return Container(
                                                                              padding: const EdgeInsets.symmetric(vertical: 8, horizontal: 10),
                                                                              child: Column(
                                                                                children: [
                                                                                  GestureDetector(
                                                                                    onTap: () {
                                                                                      Navigator.push(
                                                                                        context,
                                                                                        MaterialPageRoute(builder: (context) => PoiInfo(geo: "LatLng(${searchList[index].lat.toString()},${searchList[index].lng.toString()})", poiName: searchList[index].poiMultilingual!.en!.name.toString(), iconImage: "assets/images/restro2.png")),
                                                                                      );

                                                                                      // FocusScope.of(context).requestFocus(FocusNode());
                                                                                      // recentSearchName.add(searchList[index].poiMultilingual!.en!.name.toString());
                                                                                      // recentSearchGeo.add("LatLng(${searchList[index].lat.toString()},${searchList[index].lng.toString()})");
                                                                                      // showModalBottomSheet<void>(
                                                                                      //   isDismissible: true,
                                                                                      //   enableDrag: true,
                                                                                      //   context: context,
                                                                                      //   builder: (BuildContext context) {
                                                                                      //     return PoiInfo(
                                                                                      //       geo: "LatLng(${searchList[index].lat.toString()},${searchList[index].lng.toString()})",
                                                                                      //       poiName: searchList[index].poiMultilingual!.en!.name.toString(),
                                                                                      //       iconImage: "assets/images/restro2.png",
                                                                                      //     );
                                                                                      //   },
                                                                                      // );
                                                                                    },
                                                                                    child: Container(
                                                                                      color: Colors.white,
                                                                                      child: Row(
                                                                                        children: [
                                                                                          // const Icon(
                                                                                          //   Icons.supervised_user_circle,
                                                                                          //   size: 40,
                                                                                          // ),
                                                                                          Image.asset(CommonFunctions.iconReturn(searchList[index].subcategory ?? ""),
                                                                                              // "assets/symbols/restro.png",
                                                                                              width: 40,
                                                                                              height: 40,
                                                                                              fit: BoxFit.contain),
                                                                                          Padding(
                                                                                            padding: const EdgeInsets.only(left: 12.0),
                                                                                            child: Column(
                                                                                              mainAxisSize: MainAxisSize.min,
                                                                                              crossAxisAlignment: CrossAxisAlignment.start,
                                                                                              children: [
                                                                                                Text(
                                                                                                  "${searchList[index].poiMultilingual!.en!.name}",
                                                                                                  style: const TextStyle(fontWeight: FontWeight.bold),
                                                                                                ),
                                                                                                Text("${searchList[index].subcategory}")
                                                                                              ],
                                                                                            ),
                                                                                          )
                                                                                        ],
                                                                                      ),
                                                                                    ),
                                                                                  ),
                                                                                  const Divider(
                                                                                    thickness: 1,
                                                                                  )
                                                                                ],
                                                                              ),
                                                                            );
                                                                          }),
                                                                    )
                                                                  : Container()
                                                            ],
                                                          ),
                                                        ],
                                                      );
                                                    }));
                                          });
                                    }
                                  }),

                              BlocConsumer<MyhomeBloc, MyhomeState>(
                                  listener: (context, state) {
                                isPoiTapped = state is SecondSheetEnabled;
                              }, builder: (context, state) {
                                if (state is SecondSheetEnabled) {
                                  return DraggableScrollableSheet(
                                      initialChildSize: minSize,
                                      minChildSize: minSize,
                                      maxChildSize: 1,
                                      expand: true,
                                      snap: true,
                                      snapSizes: [minSize, 1],
                                      // controller: dragControllerPoi,
                                      builder: (BuildContext context,
                                          scrollSheetController) {
                                        // scrollController = scrollSheetController;
                                        return Container(
                                          // color: Colors.white,
                                          decoration: const BoxDecoration(
                                              color: Colors.white,
                                              borderRadius: BorderRadius.only(
                                                topLeft: Radius.circular(32.0),
                                                topRight: Radius.circular(32.0),
                                              )),
                                          child: ListView.builder(
                                              padding: EdgeInsets.zero,
                                              physics:
                                                  const ClampingScrollPhysics(),
                                              controller: scrollSheetController,
                                              itemCount: 1,
                                              itemBuilder:
                                                  (BuildContext context,
                                                      int index) {
                                                return PoiInfo(
                                                  geo: geo,
                                                  poiName: poiName,
                                                  iconImage: iconImage,
                                                  isDetail: false,
                                                  onGetDirection: () {
                                                    IndoorAtlas
                                                        .startWayfindingTo(
                                                      IAWayfindingRequest(
                                                        destination:
                                                            IACoordinate(
                                                                currentPoi
                                                                    .latitude,
                                                                currentPoi
                                                                    .longitude),
                                                        floor: currentFloor,
                                                      ),
                                                    );
                                                    BlocProvider.of<MyhomeBloc>(
                                                            context)
                                                        .add(HideSecondSheet());
                                                  },
                                                );
                                              }),
                                        );
                                      });
                                } else {
                                  return Container();
                                }
                              }),
                              BlocBuilder<MyhomeBloc, MyhomeState>(
                                builder: (context, state) {
                                  return (state is SecondSheetEnabled)
                                      ? Container(
                                          width: 50,
                                          height: 50,
                                          margin: const EdgeInsets.only(
                                              left: 15, top: 15),
                                          decoration: BoxDecoration(
                                              color: Colors.white,
                                              borderRadius:
                                                  BorderRadius.circular(25.0),
                                              boxShadow: const [
                                                BoxShadow(
                                                  color: Colors.black12,
                                                  offset: Offset(0.0, 2.0),
                                                  blurRadius: 2.0,
                                                  spreadRadius: 1.0,
                                                ),
                                              ]),
                                          child: GestureDetector(
                                            onTap: (() {
                                              // dragController.animateTo(minSize, duration: Duration(milliseconds: 500), curve: Curves.easeOutBack);
                                              // dragControllerPoi.animateTo(minSize, duration: Duration(milliseconds: 500), curve: Curves.easeOutBack);
                                              // setState(() {
                                              //   isPoiTapped = false;
                                              // });
                                              BlocProvider.of<MyhomeBloc>(
                                                      context)
                                                  .add(HideSecondSheet());
                                              BlocProvider.of<MyhomeBloc>(
                                                      context)
                                                  .add(ShowFirstSheet());
                                            }),
                                            child: const Icon(
                                              Icons.chevron_left,
                                              color: Colors.black,
                                              size: 40,
                                            ),
                                          ),
                                        )
                                      : Container();
                                },
                              ),
                            ],
                          ),
                  ),
                ],
              ),
            )),
    ));
  }

  void _onFloorPlan(bool enter, IAFloorplan floorplan) {
    // if (floorplan.id != floorplans![currentFloor].id) {
    //   _changeFloorPlanImage(floorplan);
    // }
  }

  void _onHeading(double value) {}
  // MapboxMapController? mapBoxGlobalController;
  Symbol? userLocSymbol;
  void _onLocation(IALocation value) async {
    print('LOCATION CHANGED ');
    print(value.latitude);
    print(value.longitude);
    if (userLocSymbol != null) {
      controller.removeSymbol(userLocSymbol!);
    }
    ScaffoldMessenger.of(context).showSnackBar(
      SnackBar(
        content: Text(
            " ${value.latitude.toString()}, ${value.longitude.toString()}"),
      ),
    );

    userLocSymbol = await controller.addSymbol(
      SymbolOptions(
        geometry: LatLng(value.latitude, value.longitude),
        iconImage: "assets/symbols/Oval.png",
        iconSize: 2,
      ),
    );

    // mapBoxGlobalController?.addSymbol(options);
    // IACoordinate coordinatesss = const IACoordinate(19.098519, 72.874318);
    // print("coordinatesss $coordinatesss");
    // IndoorAtlas.setLocation(coordinatesss);
  }

  void _onVenue(bool enter, IAVenue venue) {
    floorplans = venue.floorplans;
    // log('ONVENUE', name: 'enter');
    // _changeFloorPlanImage(floorplans![currentFloor]);
  }

  void _onOrientationChanged(double x, double y, double z, double w) {}

  void _onStatus(IAStatus status, String message) {}

  void _onWayfindingRoute(IARoute route, IAWayfindingRequest? request) async {
    await controller.clearLines();

    await controller.addLine(
      LineOptions(
        geometry: _getRouteLatLng(route),
        lineWidth: 5,
        lineColor: '#006DB7',
      ),
    );
  }

  void _onStyleLoaded() async {
    await addImageFromAsset('poi', 'assets/images/poi.png');
    if (floorplans != null) {
      _changeFloorPlanImage(floorplans![currentFloor]);
    }
    //controller.onSymbolTapped.add();
  }

  Future _changeFloorPlanImage(IAFloorplan floorplan) async {
    await controller.removeSource('floorPlanSrc');
    final response = await http.get(Uri.parse(floorplan.url));
    await controller.addImageSource(
      'floorPlanSrc',
      response.bodyBytes,
      LatLngQuad(
        topLeft: floorplan.topLeft.parseLatLng(),
        topRight: floorplan.topRight.parseLatLng(),
        bottomRight: floorplan.bottomRight.parseLatLng(),
        bottomLeft: floorplan.bottomLeft.parseLatLng(),
      ),
    );
    await controller.addImageLayerBelow(
        'floorPlan', 'floorPlanSrc', controller.lineManager!.layerIds.first);
    await controller.animateCamera(
      CameraUpdate.newLatLngZoom(
        LatLng(floorplan.center.latitude, floorplan.center.longitude),
        16.0,
      ),
    );
    addPOIs(getPOIS());
  }

  List<IAPOI> getPOIS() {
    final List<IAPOI> pois = [];
    pois.addAll([
      IAPOI(
        id: '1',
        name: 'Burger King',
        floor: 2,
        coordinate: const IACoordinate(19.09614069661849, 72.87494458659683),
        payload: '',
      ),
      IAPOI(
        id: '2',
        name: 'Shiv Sagar',
        floor: 2,
        coordinate: const IACoordinate(19.09930713759286, 72.87373404109417),
        payload: '',
      ),
      IAPOI(
        id: '3',
        name: 'Irani Cafe',
        floor: 2,
        coordinate: const IACoordinate(19.09646722213212, 72.8744603204529),
        payload: '',
      ),
    ]);
    allPOIS = pois;
    return pois;
  }

  void addPOIs(List<IAPOI> pois) async {
    await controller.clearSymbols();
    for (var poi in pois) {
      await controller.addSymbol(
        SymbolOptions(
          iconImage: 'poi',
          geometry: LatLng(poi.coordinate.latitude, poi.coordinate.longitude),
          iconSize: 2.0,
          textField: poi.name,
        ),
      );
    }
  }

  Future<void> addImageFromAsset(String name, String assetName) async {
    final ByteData bytes = await rootBundle.load(assetName);
    final Uint8List list = bytes.buffer.asUint8List();
    return controller.addImage(name, list);
  }

  List<LatLng> _getRouteLatLng(IARoute route) {
    print("GetRouteLatLng ${route.legs}");
    List<LatLng> geometry = [];
    for (var leg in route.legs) {
      print(" GetRouteLatLng22 ${leg.end.coordinate.latitude}");
      geometry
        ..add(
          LatLng(leg.begin.coordinate.latitude, leg.begin.coordinate.longitude),
        )
        ..add(
          LatLng(leg.end.coordinate.latitude, leg.end.coordinate.longitude),
        );
    }
    return geometry;
  }
}

Widget searchItem(fontSize, String propName, String propAddress) {
  return Row(
    mainAxisAlignment: MainAxisAlignment.start,
    children: [
      Image.asset(
        "assets/images/restro2.png",
        height: 30,
        width: 30,
      ),
      const SizedBox(width: 10),
      Column(
        crossAxisAlignment: CrossAxisAlignment.start,
        children: [
          Text(
            propName,
            style: TextStyle(fontSize: fontSize),
          ),
          Text(
            propAddress,
            style: const TextStyle(fontSize: 10),
          )
        ],
      ),
      const SizedBox(
        height: 20,
      )
    ],
  );
}
