import 'package:flutter/material.dart';
import 'package:flutter/services.dart';
import 'package:insuideindoor/data/ia/indooratlas.dart';
import 'package:insuideindoor/data/models/ia_wayfindingrequest.dart';
import 'package:insuideindoor/data/models/models.dart';
import 'package:insuideindoor/main/MyHome.dart';
import 'package:insuideindoor/main/common_widget.dart';
import 'package:insuideindoor/main/direction.dart';
import 'package:insuideindoor/main/filter_data.dart';
// import 'package:insuideindoor/main/poiInfo.dart';
import 'package:insuideindoor/main/poi_model.dart';

import '../utils/common_functions.dart';

class ToDirection extends StatefulWidget {
  final String kamalString;
  const ToDirection({Key? key, required this.kamalString}) : super(key: key);

  @override
  State<ToDirection> createState() => _ToDirectionState();
}

class _ToDirectionState extends State<ToDirection> {
  TextEditingController fromController = TextEditingController();
  TextEditingController toController = TextEditingController();

  FocusNode fromFocus = FocusNode();
  FocusNode toFocus = FocusNode();

  var bordrWdth = 2.0;
  bool canCloseFrom = false;
  bool canCloseTo = false;

  @override
  void initState() {
    // TODO: implement initState
    super.initState();
    SystemChrome.setSystemUIOverlayStyle(SystemUiOverlayStyle.dark);
    fromController.text = "Your Location";
  }

  @override
  Widget build(BuildContext context) {
    double width = MediaQuery.of(context).size.width;
    double height = MediaQuery.of(context).size.height;
    // double btnPadding = 10.0;
    double btnSize = 25.0;
    double fontSize = 16.0;
    return Scaffold(
        // appBar: AppBar(
        //   backgroundColor: Colors.white,
        //   automaticallyImplyLeading: false,
        //   title: GestureDetector(
        //     onTap: (() {
        //       Navigator.pop(context);
        //     }),
        //     child: const Icon(
        //       Icons.arrow_back,
        //       color: Colors.black,
        //     ),
        //   ),
        //   elevation: 0,
        // ),
        body:
            //  DraggableScrollableSheet(
            //     initialChildSize: 1,
            //     minChildSize: 0.1,
            //     maxChildSize: 1,
            //     snap: true,
            //     snapSizes: [0.387, 1],
            //     builder: (BuildContext context, scrollSheetController) {
            //       return
            GestureDetector(
      onTap: () {
        FocusScope.of(context).requestFocus(new FocusNode());
        // searchFocus.
      },
      child: Container(
          decoration: const BoxDecoration(
              color: Colors.white,
              borderRadius: BorderRadius.all(Radius.circular(16.0))),
          child: ListView.builder(
              padding: EdgeInsets.zero,
              physics: const ClampingScrollPhysics(),
              // controller: scrollSheetController,
              itemCount: 1,
              itemBuilder: (BuildContext context, int index) {
                return Column(
                  children: [
                    const SizedBox(height: 40),
                    Container(
                      width: width - 30,
                      margin: const EdgeInsets.symmetric(horizontal: 15),
                      child: Stack(
                        children: [
                          Column(
                            crossAxisAlignment: CrossAxisAlignment.end,
                            children: [
                              Row(
                                crossAxisAlignment: CrossAxisAlignment.center,
                                mainAxisAlignment:
                                    MainAxisAlignment.spaceBetween,
                                children: [
                                  GestureDetector(
                                    onTap: (() {
                                      Navigator.pop(context);
                                    }),
                                    child: Icon(
                                      Icons.chevron_left,
                                      color: Colors.black,
                                      size: width * 0.1,
                                    ),
                                  ),
                                  //FROM
                                  Container(
                                    width: width * 0.88 - 30,
                                    // color: Colors.teal,
                                    alignment: Alignment.centerLeft,
                                    child: TextFormField(
                                      focusNode: fromFocus,
                                      controller: fromController,
                                      scrollPadding: EdgeInsets.zero,
                                      // textAlignVertical: TextAlignVertical.center,
                                      decoration: InputDecoration(
                                        isDense: true,
                                        // contentPadding: const EdgeInsets.only(top: 0.0, bottom: 0.0, left: 0.0, right: 5.0),
                                        contentPadding: EdgeInsets.zero,
                                        prefixIcon: Icon(Icons.circle_outlined,
                                            size: btnSize,
                                            color: Color(0xFF555555)),
                                        suffix: canCloseFrom
                                            ? GestureDetector(
                                                onTap: () {
                                                  fromController.text = "";
                                                  // fromController.notifyListeners();
                                                },
                                                child: Icon(
                                                  Icons.close,
                                                  size: btnSize + 5,
                                                  color: Color(0xFF555555),
                                                ),
                                              )
                                            : null,
                                        hintText: "From",
                                        hintStyle: const TextStyle(
                                            fontWeight: FontWeight.bold,
                                            fontSize: 15),
                                        border: OutlineInputBorder(
                                            borderRadius:
                                                BorderRadius.circular(40),
                                            // borderSide: BorderSide(color: Color(0xffEAEBED)
                                            borderSide: BorderSide(
                                                color: Color(0xffCACACA),
                                                width: bordrWdth)),
                                        disabledBorder: OutlineInputBorder(
                                            borderRadius:
                                                BorderRadius.circular(40),
                                            // borderSide: BorderSide(color: Color(0xffEAEBED)
                                            borderSide: BorderSide(
                                                color: Color(0xffCACACA),
                                                width: bordrWdth)),
                                        enabledBorder: OutlineInputBorder(
                                            borderRadius:
                                                BorderRadius.circular(40),
                                            borderSide: BorderSide(
                                                color: Color(0xffEAEBED),
                                                width: bordrWdth)),
                                        focusedBorder: OutlineInputBorder(
                                            borderRadius:
                                                BorderRadius.circular(40),
                                            borderSide: BorderSide(
                                                color: Color(0xffEAEBED),
                                                width: bordrWdth)),
                                      ),
                                      onChanged: (text) {
                                        if (text.isNotEmpty) {
                                          searchList.clear();
                                          for (int i = 0;
                                              i < dataPois.length;
                                              i++) {
                                            Datum d = dataPois[i];

                                            if (d.category
                                                    .toString()
                                                    .toLowerCase()
                                                    .contains(text) ||
                                                d.subcategory
                                                    .toString()
                                                    .toLowerCase()
                                                    .contains(text) ||
                                                d.poiMultilingual!.en!.name
                                                    .toString()
                                                    .toLowerCase()
                                                    .contains(text)) {
                                              searchList.add(d);
                                            }
                                          }

                                          if (!canCloseFrom) {
                                            canCloseFrom = true;
                                          }
                                        } else {
                                          searchList.clear();
                                          if (canCloseFrom) {
                                            canCloseFrom = false;
                                          }
                                        }
                                        setState(() {});
                                      },
                                    ),
                                  ),
                                ],
                              ),

                              Container(
                                color: Colors.white,
                                height: 20,
                              ),
                              //TO
                              SizedBox(
                                width: width * 0.88 - 30,
                                child: TextFormField(
                                  focusNode: toFocus,
                                  controller: toController,
                                  scrollPadding: EdgeInsets.zero,
                                  decoration: InputDecoration(
                                    // fillColor: Color(0xffEAEBED),
                                    isDense: true,
                                    contentPadding: const EdgeInsets.only(
                                        top: 0.0,
                                        bottom: 0.0,
                                        left: 0.0,
                                        right: 5.0),
                                    prefixIcon: Icon(Icons.location_pin,
                                        size: btnSize,
                                        color: Color(0xFF555555)),
                                    suffix: canCloseTo
                                        ? GestureDetector(
                                            onTap: () {
                                              toController.text = "";
                                              // fromController.notifyListeners();
                                            },
                                            child: Icon(
                                              Icons.close,
                                              size: btnSize + 5,
                                              color: Color(0xFF555555),
                                            ),
                                          )
                                        : null,

                                    hintText: "To",
                                    hintStyle: const TextStyle(
                                        fontWeight: FontWeight.bold,
                                        fontSize: 15),
                                    border: OutlineInputBorder(
                                        borderRadius: BorderRadius.circular(40),
                                        borderSide: BorderSide(
                                            color: Color(0xffCACACA),
                                            width: bordrWdth)),
                                    disabledBorder: OutlineInputBorder(
                                        borderRadius: BorderRadius.circular(40),
                                        borderSide: BorderSide(
                                            color: Color(0xffCACACA),
                                            width: bordrWdth)),
                                    enabledBorder: OutlineInputBorder(
                                        borderRadius: BorderRadius.circular(40),
                                        borderSide: BorderSide(
                                            color: Color(0xffEAEBED),
                                            width: bordrWdth)),
                                    focusedBorder: OutlineInputBorder(
                                        borderRadius: BorderRadius.circular(40),
                                        borderSide: BorderSide(
                                            color: Color(0xffEAEBED),
                                            width: bordrWdth)),
                                  ),
                                  // onTap: () {
                                  //   readOnly = !readOnly;
                                  //   setState(() {});
                                  // },

                                  // initialValue:
                                  //     searchController.text,
                                  onChanged: (text) {
                                    if (text.isNotEmpty) {
                                      searchList.clear();
                                      for (int i = 0;
                                          i < dataPois.length;
                                          i++) {
                                        Datum d = dataPois[i];

                                        if (d.category
                                                .toString()
                                                .toLowerCase()
                                                .contains(text) ||
                                            d.subcategory
                                                .toString()
                                                .toLowerCase()
                                                .contains(text) ||
                                            d.poiMultilingual!.en!.name
                                                .toString()
                                                .toLowerCase()
                                                .contains(text)) {
                                          searchList.add(d);
                                        }
                                      }
                                      // searchList = dataPois
                                      //     .where((element) =>
                                      //         element.category
                                      //             .toString()
                                      //             .toLowerCase()
                                      //             .contains(text) ||
                                      //         element.subcategory
                                      //             .toString()
                                      //             .toLowerCase()
                                      //             .contains(text))
                                      //     .toList();

                                      if (!canCloseTo) {
                                        canCloseTo = true;
                                      }
                                    } else {
                                      searchList.clear();
                                      if (canCloseTo) {
                                        canCloseTo = false;
                                      }
                                    }
                                    setState(() {});
                                  },
                                  // autofocus: true,
                                  // readOnly: readOnly,
                                ),
                              ),
                            ],
                          ),
                          Container(
                            color: const Color(0xFF333333),
                            width: 1.5,
                            height: 35,
                            margin: EdgeInsets.only(
                                left: width * 0.11 + 26.75, top: 40),
                          ),
                        ],
                      ),
                    ),
                    Stack(
                      children: [
                        Column(
                          mainAxisSize: MainAxisSize.min,
                          children: [
                            const SizedBox(height: 10),
                            SizedBox(
                              child: SingleChildScrollView(
                                padding:
                                    const EdgeInsets.symmetric(horizontal: 20),
                                child: Column(
                                  mainAxisAlignment: MainAxisAlignment.start,
                                  crossAxisAlignment: CrossAxisAlignment.start,
                                  children: [
                                    Text(
                                      "Explore",
                                      style: TextStyle(
                                          fontSize: fontSize,
                                          fontStyle: FontStyle.italic),
                                    ),
                                    const SizedBox(height: 15),
                                    Row(
                                        mainAxisAlignment:
                                            MainAxisAlignment.spaceAround,
                                        children: [
                                          Column(
                                            mainAxisAlignment:
                                                MainAxisAlignment.start,
                                            crossAxisAlignment:
                                                CrossAxisAlignment.start,
                                            children: [
                                              GestureDetector(
                                                onTap: () {},
                                                child: GestureDetector(
                                                  onTap: () {
                                                    Navigator.push(
                                                      context,
                                                      MaterialPageRoute(
                                                          builder: (context) =>
                                                              const FilterData(
                                                                searchData:
                                                                    'restaurant',
                                                              )),
                                                    );
                                                  },
                                                  child: Row(
                                                    mainAxisAlignment:
                                                        MainAxisAlignment
                                                            .spaceBetween,
                                                    children: [
                                                      Image.asset(
                                                        // "assets/symbols/Oval.png",
                                                        "assets/images/restro2.png",
                                                        // "assets/symbols/neww.png",
                                                        height: 30,
                                                        width: 30,
                                                      ),
                                                      const SizedBox(width: 10),
                                                      Text(
                                                        "Restaurants",
                                                        style: TextStyle(
                                                            fontSize: fontSize),
                                                      )
                                                    ],
                                                  ),
                                                ),
                                              ),
                                              const SizedBox(
                                                height: 15,
                                              ),
                                              GestureDetector(
                                                onTap: () {
                                                  Navigator.push(
                                                    context,
                                                    MaterialPageRoute(
                                                        builder: (context) =>
                                                            const FilterData(
                                                              searchData:
                                                                  'shopping',
                                                            )),
                                                  );
                                                },
                                                child: Row(
                                                  children: [
                                                    Image.asset(
                                                      "assets/images/shopping.png",
                                                      height: 35,
                                                      width: 35,
                                                    ),
                                                    const SizedBox(width: 10),
                                                    Text(
                                                      "Shopping",
                                                      style: TextStyle(
                                                          fontSize: fontSize),
                                                    )
                                                  ],
                                                ),
                                              )
                                            ],
                                          ),
                                          Column(
                                            crossAxisAlignment:
                                                CrossAxisAlignment.start,
                                            children: [
                                              GestureDetector(
                                                onTap: () {
                                                  Navigator.push(
                                                    context,
                                                    MaterialPageRoute(
                                                        builder: (context) =>
                                                            const FilterData(
                                                              searchData:
                                                                  'facilities',
                                                            )),
                                                  );
                                                },
                                                child: Row(
                                                  children: [
                                                    Image.asset(
                                                      "assets/images/facilities.png",
                                                      height: 35,
                                                      width: 35,
                                                    ),
                                                    const SizedBox(width: 10),
                                                    Text(
                                                      "Facilities",
                                                      style: TextStyle(
                                                          fontSize: fontSize),
                                                    )
                                                  ],
                                                ),
                                              ),
                                              const SizedBox(
                                                height: 15,
                                              ),
                                              GestureDetector(
                                                onTap: () {
                                                  Navigator.push(
                                                    context,
                                                    MaterialPageRoute(
                                                        builder: (context) =>
                                                            const FilterData(
                                                              searchData:
                                                                  'utilities',
                                                            )),
                                                  );
                                                },
                                                child: Row(
                                                  children: [
                                                    Image.asset(
                                                      "assets/images/utilities.png",
                                                      height: 35,
                                                      width: 35,
                                                    ),
                                                    const SizedBox(width: 10),
                                                    Text(
                                                      "Utilities",
                                                      style: TextStyle(
                                                          fontSize: fontSize),
                                                    )
                                                  ],
                                                ),
                                              )
                                            ],
                                          )
                                        ]),
                                    const SizedBox(
                                      height: 20,
                                    ),
                                    Text(
                                      "Recent Searches",
                                      style: TextStyle(
                                          fontSize: fontSize,
                                          fontStyle: FontStyle.italic),
                                    ),
                                    const SizedBox(
                                      height: 40,
                                    ),
                                    searchItem(fontSize, "Baker Street",
                                        "Level 4, Security Hold Area"),
                                    const SizedBox(
                                      height: 15,
                                    ),
                                    searchItem(fontSize, "Baker Street",
                                        "Level 4, Security Hold Area"),
                                    const SizedBox(
                                      height: 15,
                                    ),
                                    searchItem(fontSize, "Baker Street",
                                        "Level 4, Security Hold Area"),
                                    const SizedBox(
                                      height: 15,
                                    ),
                                    searchItem(fontSize, "Baker Street",
                                        "Level 4, Security Hold Area"),
                                    const SizedBox(
                                      height: 15,
                                    ),
                                    searchItem(fontSize, "Baker Street",
                                        "Level 4, Security Hold Area"),
                                    const SizedBox(
                                      height: 15,
                                    ),
                                    searchItem(fontSize, "Baker Street",
                                        "Level 4, Security Hold Area"),
                                    const SizedBox(
                                      height: 15,
                                    ),
                                    searchItem(fontSize, "Baker Street",
                                        "Level 4, Security Hold Area"),
                                    const SizedBox(
                                      height: 15,
                                    ),
                                  ],
                                ),
                              ),
                            ),
                          ],
                        ),
                        if (searchList != null && searchList.length > 0)
                          Container(
                            // height: double.minPositive,
                            height: height * 0.87,
                            color: Colors.white,
                            child: ListView.builder(
                                itemCount: searchList.length,
                                itemBuilder: (BuildContext context, int index) {
                                  return GestureDetector(
                                    onTap: () {
                                      String tappedName = searchList[index]
                                              .poiMultilingual
                                              ?.en
                                              ?.name ??
                                          "No Name";
                                      double inLat = searchList[index].lat!;
                                      double inLng = searchList[index].lng!;
                                      String imgSubCat =
                                          searchList[index].subcategory ?? "";
                                      // print(searchList[index].);
                                      // Navigator.pop(context);
                                      // showModalBottomSheet<void>(
                                      //   context: context,
                                      //   backgroundColor: Colors.transparent,
                                      //   builder: (BuildContext context) {
                                      //     return Container(
                                      //       height: height * 0.345,
                                      //       width: width,
                                      //       decoration: const BoxDecoration(
                                      //           color: Colors.white,
                                      //           borderRadius: BorderRadius.only(
                                      //               topLeft:
                                      //                   Radius.circular(32),
                                      //               topRight:
                                      //                   Radius.circular(32))),
                                      //       child: Padding(
                                      //         padding:
                                      //             const EdgeInsets.all(10.0),
                                      //         child: SingleChildScrollView(
                                      //           child: Column(
                                      //             crossAxisAlignment:
                                      //                 CrossAxisAlignment.start,
                                      //             children: [
                                      //               Align(
                                      //                 alignment:
                                      //                     Alignment.center,
                                      //                 child: Container(
                                      //                   width: width * 0.2,
                                      //                   height: 5,
                                      //                   decoration: BoxDecoration(
                                      //                       color: const Color(
                                      //                           0xffEAEBED),
                                      //                       borderRadius:
                                      //                           BorderRadius
                                      //                               .circular(
                                      //                                   10.0)),
                                      //                 ),
                                      //               ),
                                      //               Row(
                                      //                 children: [
                                      //                   Column(
                                      //                     children: [
                                      //                       Row(
                                      //                         children: [
                                      //                           Icon(Icons
                                      //                               .nordic_walking),
                                      //                           Text("12 Mins")
                                      //                         ],
                                      //                       ),
                                      //                       Text("500m")
                                      //                     ],
                                      //                   ),
                                      //                   ElevatedButton(
                                      //                       onPressed: () {},
                                      //                       child: Row(
                                      //                         children: [
                                      //                           Text("Start"),
                                      //                           Icon(Icons
                                      //                               .navigate_before)
                                      //                         ],
                                      //                       ))
                                      //                 ],
                                      //               ),
                                      //               Text("12 Mins")
                                      //             ],
                                      //           ),
                                      //         ),
                                      //       ),
                                      //     );
                                      //   },
                                      // );
                                      toController.clear();
                                      Navigator.push(
                                        context,
                                        MaterialPageRoute(
                                            builder: (context) => Direction(
                                                  kamalString:
                                                      widget.kamalString,
                                                  toText: tappedName,
                                                  toLat: inLat,
                                                  toLng: inLng,
                                                  iconImage: imgSubCat,
                                                )),
                                      );

                                      // IndoorAtlas.startWayfindingTo(
                                      //   IAWayfindingRequest(
                                      //     destination: IACoordinate(
                                      //         searchList[index].lat!,
                                      //         searchList[index].lng!),
                                      //     floor: 2,
                                      //   ),
                                      // );

                                      print(
                                          "fromFocus >> ${fromFocus.hasFocus}    toFocus  >>  ${toFocus.hasFocus}");

                                      if (fromFocus.hasFocus) {
                                        setState(() {
                                          fromController.text =
                                              searchList[index]
                                                  .poiMultilingual!
                                                  .en!
                                                  .name
                                                  .toString();
                                          fromFocus.unfocus();
                                        });
                                      } else if (toFocus.hasFocus) {
                                        setState(() {
                                          toController.text = searchList[index]
                                              .poiMultilingual!
                                              .en!
                                              .name
                                              .toString();
                                          toFocus.unfocus();
                                        });
                                      }

                                      // if (toController.text.isNotEmpty) {
                                      //   setState(() {
                                      //     toController.text = searchList[index].poiMultilingual!.en!.name.toString();
                                      //   });
                                      // } else {
                                      //   setState(() {
                                      //     fromController.text = searchList[index].poiMultilingual!.en!.name.toString();
                                      //   });
                                      // }
                                      searchList.clear();
                                      // Navigator.push(
                                      //   context,
                                      //   MaterialPageRoute(
                                      //       builder: (context) => PoiInfo(
                                      //             // geo: argument.options.geometry.toString(),
                                      //             geo: searchList[index]
                                      //                 .lat
                                      //                 .toString(),
                                      //             poiName: searchList[index]
                                      //                 .poiMultilingual!
                                      //                 .en!
                                      //                 .name
                                      //                 .toString(),
                                      //             iconImage:
                                      //                 "assets/images/restro2.png",
                                      //           )),
                                      // );
                                    },
                                    child: Container(
                                      padding: EdgeInsets.symmetric(
                                          vertical: 8, horizontal: 10),
                                      color: Colors.white,
                                      child: Column(
                                        children: [
                                          Row(
                                            children: [
                                              // Image.asset(iconReturn()),
                                              // Icon(
                                              //   Icons.supervised_user_circle,
                                              //   size: 40,
                                              // ),
                                              Image.asset(
                                                  CommonFunctions.iconReturn(
                                                      searchList[index]
                                                              .subcategory ??
                                                          ""),
                                                  // "assets/symbols/restro.png",
                                                  width: 40,
                                                  height: 40,
                                                  fit: BoxFit.contain),
                                              Padding(
                                                padding: const EdgeInsets.only(
                                                    left: 12.0),
                                                child: Column(
                                                  mainAxisSize:
                                                      MainAxisSize.min,
                                                  crossAxisAlignment:
                                                      CrossAxisAlignment.start,
                                                  children: [
                                                    Text(
                                                      "${searchList[index].poiMultilingual!.en!.name}",
                                                      style: TextStyle(
                                                          fontWeight:
                                                              FontWeight.bold),
                                                    ),
                                                    Text(
                                                        "${searchList[index].subcategory}")
                                                  ],
                                                ),
                                              )
                                            ],
                                          ),
                                          Divider(
                                            thickness: 1,
                                          )
                                        ],
                                      ),
                                    ),
                                  );
                                }),
                          ),
                      ],
                    ),
                  ],
                );
              })),
    )
        // }),
        );
  }
}
