import 'package:bloc/bloc.dart';
import 'package:equatable/equatable.dart';
import 'package:mapbox_gl/mapbox_gl.dart';

part 'mapbox_gl_event.dart';
part 'mapbox_gl_state.dart';

const mapboxStyles = [
  MapboxStyles.TRAFFIC_DAY,
  MapboxStyles.TRAFFIC_NIGHT,
  MapboxStyles.DARK,
  MapboxStyles.MAPBOX_STREETS,
  MapboxStyles.LIGHT,
  MapboxStyles.SATELLITE,
  MapboxStyles.OUTDOORS,
  MapboxStyles.SATELLITE_STREETS
];

class MapboxGlBloc extends Bloc<MapboxGlEvent, MapboxGlState> {
  MapboxGlBloc() : super(MapboxGlInitial()) {
    on<ChangeMapStyle>((event, emit) {
      final index = (event.currentIndex + 1) % mapboxStyles.length;
      emit(
        OnChangeMapStyle(style: mapboxStyles[index]),
      );
    });
  }
}
